//----------------------------------------------------------------------//
// NyanFi																//
//  IvVݒ														//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <tchar.h>
#include <memory>
#include <mmsystem.h>
#include <Vcl.FileCtrl.hpp>
#include <RegularExpressions.hpp>
#include "UserFunc.h"
#include "UserMdl.h"
#include "Global.h"
#include "CmdListDlg.h"
#include "OptDlg.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TOptionDlg *OptionDlg = NULL;

//---------------------------------------------------------------------------
__fastcall TOptionDlg::TOptionDlg(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::FormCreate(TObject *Sender)
{
	cursor_HourGlass();
	set_ComboBox_AutoComp(this);

	FindMarkList = new MarkList(this);
	ColBufList	 = new TStringList();

	set_ButtonMark(FindDownBtn, UBMK_BDOWN);
	set_ButtonMark(FindUpBtn,   UBMK_BUP);

	for (int i=0; i<MAX_KEYTABS; i++) KeyListBuf[i] = new TStringList();

	set_ComboBoxText(LayoutComboBox,
		_T("t@CXg\r\nt@CXg\r\nt@CXgE\r\n"));

	set_ComboBoxText(SizeFmtComboBox,
		_T("GB/MB/oCg\r\nGB/MB/KB/oCg\r\nGB/MB/KB\r\n"));

	set_ComboBoxText(TabStyleComboBox,
		_T("^u\r\n^u()\r\n{^\r\ntbg\r\n"));

	set_ComboBoxText(ScrBarStyleComboBox,
		_T("W\r\nVv\r\nVv(3/4)\r\nVv(1/2)\r\nVv(摜)\r\n"));

	set_ComboBoxText(FontComboBox,
		_T("Xg\r\n")
		_T("t@C\r\n")
		_T("eLXgvr[\r\n")
		_T("O\r\n")
		_T("eLXgrA[\r\n")
		_T("GREPʃXg\r\n")
		_T("fBNg\r\n")
		_T("hCu\r\n")
		_T("ꗗ̃wb_\r\n")
		_T("rA[wb_\r\n")
		_T("ꗗ_CAO\r\n")
		_T("qg\r\n")
		_T("Xe[^Xo[\r\n")
		_T("_CAO\r\n")
		_T("c[{^\r\n")
		_T("^uo[\r\n"));

	set_ComboBoxText(SizeDecDgtComboBox, _T("0\r\n1\r\n2\r\n3\r\n"));
	set_ComboBoxText(MaxTasksComboBox,   _T("1\r\n2\r\n3\r\n4\r\n"));

	OptColListBox->Items->Text =
		"bgList=Xg̔wiF\r\n"
		"fgList=Xg̕F\r\n"
		"bgArc=zfBNg̔wiF\r\n"
		"bgFind=ʃXg̔wiF\r\n"
		"bgWork=[NXg̔wiF\r\n"
		"bgFTP=FTP[g̔wiF\r\n"
		"selItem=Iڂ̔wiF\r\n"
		"oppItem=΃pXIڂ̔wiF\r\n"
		"fgSelItem=Iڂ̕F\r\n"
		"bgMark=}[Nڂ̔wiF\r\n"
		"matchItem=INC.T[`̃}b`ڔwiF\r\n"
		"Folder=fBNg̕F\r\n"
		"SymLink=fBNg(V{bN)̕F\r\n"
		"ReadOnly=ǂݍݐp̕F\r\n"
		"Hidden=B̕F\r\n"
		"System=VXe̕F\r\n"
		"Cursor=CJ[\̐F\r\n"
		"bgScrBar=|VvXN[o[̔wiF\r\n"
		"bgScrKnob=VvXN[mu̐F\r\n"
		"frScrKnob=VvXN[mu̗֊sF\r\n"
		"Splitter=E\r\n"
		"bgTlBar1=c[o[̃Of[VJnF\r\n"
		"bgTlBar2=c[o[̃Of[VIF\r\n"
		"fgTlBar=c[o[̕F\r\n"
		"htTlBar=c[o[̃zbggbLOF\r\n"
		"bgTabBar=^uo[̔wiF\r\n"
		"bgActTab=ANeBuȃ^u̔wiF\r\n"
		"bgInAcTab=ANeBuȃ^u̔wiF\r\n"
		"frmTab=^u̗֊s\r\n"
		"fgTab=^u̕F\r\n"
		"bgListHdr=Xgwb_̔wiF\r\n"
		"fgListHdr=Xgwb_̕F\r\n"
		"bgDirInf=fBNg̔wiF\r\n"
		"fgDirInf=fBNg̕F\r\n"
		"bgDirRel=fBNg֌W̔wiF\r\n"
		"fgDirRel=fBNg֌W̕F\r\n"
		"bgDrvInf=hCu̔wiF\r\n"
		"fgDrvInf=hCu̕F\r\n"
		"bgInf=|t@C̔wiF\r\n"
		"fgInf=t@C̕F\r\n"
		"fgInfNam=t@C̍ږF\r\n"
		"bgTxtPrv=eLXgvr[̔wiF\r\n"
		"fgTxtPrv=eLXgvr[̕F\r\n"
		"bgLog=O̔wiF\r\n"
		"fgLog=O̕F\r\n"
		"bgTask=^XNԕ\̔wiF\r\n"
		"fgPrgBar=^XNio[F\r\n"
		"bgPrgBar=^XNiwiF\r\n"
		"Error=G[/ӂ̕F\r\n"
		"bgView=|eLXgrA[̔wiF\r\n"
		"fgView=eLXgrA[̕F\r\n"
		"Margin=eLXgrA[̗]\r\n"
		"bgRuler=[̔wiF\r\n"
		"fgRuler=[̖ڐF\r\n"
		"bgLineNo=sԍwiF\r\n"
		"LineNo=sԍF\r\n"
		"Mark=s}[N\r\n"
		"bdrLine=sԍE\r\n"
		"bdrFold=܂ԂE\r\n"
		"bdrFixed=Œ蒷\̏cr\r\n"
		"Comment=|Rg̕F\r\n"
		"Strings=̕F\r\n"
		"Reserved=\̕F\r\n"
		"Symbol=V{̕F\r\n"
		"Numeric=l̕F\r\n"
		"fgEmpBin1=oCiF1\r\n"
		"fgEmpBin2=oCiF2\r\n"
		"fgEmpBin3=oCiF3\r\n"
		"Headline=o̕F\r\n"
		"Ruby=r\r\n"
		"URL=URL̕F\r\n"
		"LocalLink=[Jt@Cւ̃N\r\n"
		"fgEmp=F\r\n"
		"bgEmp=wiF\r\n"
		"TAB=^u\F\r\n"
		"CR=s\F\r\n"
		"HR=r̐F\r\n"
		"Ctrl=Rg[R[h\r\n"
		"bgImage=|摜̔wiF\r\n"
		"bgDblPg=J\̗]F\r\n"
		"bgWMF=^t@C̔wiF\r\n"
		"bdrThumb=TlC̋E\r\n"
		"ThumbExif=TlCExif\r\n"
		"ImgGrid=摜Obh\r\n"
		"bgHint=|qg\̔wiF\r\n"
		"fgHint=qg\̕F\r\n"
		"bgWarn=x\̔wiF\r\n"
		"Invalid=ȍڂ̔wiF\r\n"
		"Illegal=sȓ͍ڂ̔wiF\r\n"
		"OptFind=IvVݒ̌\r\n";

	TimColListBox->Items->Text =
		"Tim1H=1Ԉȓ\r\n"
		"Tim3H=3Ԉȓ\r\n"
		"Tim1D=1ȓ\r\n"
		"Tim3D=3ȓ\r\n"
		"Tim7D=7ȓ\r\n"
		"Tim1M=1ȓ\r\n"
		"Tim3M=3ȓ\r\n"
		"Tim6M=6ȓ\r\n"
		"Tim1Y=1Nȓ\r\n"
		"Tim3Y=3Nȓ\r\n"
		"TimOld=O\r\n"
		"Size4G=|4GBȏ\r\n"
		"Size1G=1GBȏ\r\n"
		"Size1M=1MBȏ\r\n"
		"Size1K=1KBȏ\r\n"
		"SizeLT=1KB\r\n"
		"Size0=0\r\n";

	set_ComboBoxText(BgImgModeComboBox,
		_T("\\r\n")
		_T("2ʂɓnĕ\\r\n")
		_T("ꂼɕ\\r\n")
		_T("fXNgbvwi\\r\n"));
	set_ComboBoxText(BgImgSubModeComboBox,
		_T("ɕ\\r\n")
		_T("ׂĕ\\r\n")
		_T("\TCYɃXgb`\r\n")
		_T("\TCYɍ킹Đ؂o\r\n"));

	set_ComboBoxText(ScaleOptComboBox,
		_T("jAXglCo[\r\noCjA\r\noCL[rbN\r\nt@gTvO\r\nԂȂ\r\n"));

	//}EXzC[
	set_ComboBoxText(WheelCmdF0ComboBox,
		_T("ScrollUp/ScrollDown\r\n")
		_T("PageUp/PageDown\r\n")
		_T("CursorUp/CursorDown\r\n")
		_T("PrevDrive/NextDrive\r\n")
		_T("PrevTab/NextTab\r\n")
		_T("BackDirHist/ForwardDirHist\r\n")
		_T("BorderLeft/BorderRight\r\n")
		_T("ScrollUpLog/ScrollDownLog\r\n")
		_T("ScrollUpText/ScrollDownText\r\n")
		_T("SetSubSize_-16/SetSubSize_+16\r\n")
		_T("ZoomIn/ZoomOut\r\n")
		_T("PrevNyanFi/NextNyanFi\r\n"));
	WheelCmdF1ComboBox->Items->Assign(WheelCmdF0ComboBox->Items);
	WheelCmdF2ComboBox->Items->Assign(WheelCmdF0ComboBox->Items);
	WheelCmdF3ComboBox->Items->Assign(WheelCmdF0ComboBox->Items);

	set_ComboBoxText(WheelCmdV0ComboBox,
		_T("ScrollUp/ScrollDown\r\n")
		_T("ScrollCursorUp/ScrollCursorDown\r\n")
		_T("CursorUp/CursorDown\r\n")
		_T("PageUp/PageDown\r\n")
		_T("ZoomIn/ZoomOut\r\n")
		_T("PrevFile/NextFile\r\n")
		_T("PrevNyanFi/NextNyanFi\r\n"));
	WheelCmdV1ComboBox->Items->Assign(WheelCmdV0ComboBox->Items);
	WheelCmdV2ComboBox->Items->Assign(WheelCmdV0ComboBox->Items);
	WheelCmdV3ComboBox->Items->Assign(WheelCmdV0ComboBox->Items);

	set_ComboBoxText(WheelCmdI0ComboBox,
		_T("PrevFile/NextFile\r\n")
		_T("PrevPage/NextPage\r\n")
		_T("ScrollUp/ScrollDown\r\n")
		_T("ScrollLeft/ScrollRight\r\n")
		_T("ZoomIn/ZoomOut\r\n")
		_T("RotateLeft/RotateRight\r\n")
		_T("PrevNyanFi/NextNyanFi\r\n"));
	WheelCmdI1ComboBox->Items->Assign(WheelCmdI0ComboBox->Items);
	WheelCmdI2ComboBox->Items->Assign(WheelCmdI0ComboBox->Items);
	WheelCmdI3ComboBox->Items->Assign(WheelCmdI0ComboBox->Items);

	//}EX{^
	set_ComboBoxText(WheelBtnF0ComboBox,
		_T("ToRoot\r\n")
		_T("ToParent\r\n")
		_T("BackDirHist\r\n")
		_T("ForwardDirHist\r\n")
		_T("EqualListWidth\r\n")
		_T("HomeWorkList\r\n")
		_T("ZoomReset\r\n"));
	WheelBtnF1ComboBox->Items->Assign(WheelBtnF0ComboBox->Items);
	WheelBtnF2ComboBox->Items->Assign(WheelBtnF0ComboBox->Items);
	WheelBtnF3ComboBox->Items->Assign(WheelBtnF0ComboBox->Items);

	set_ComboBoxText(X1BtnFComboBox,
		_T("BackDirHist\r\n")
		_T("ForwardDirHist\r\n")
		_T("ToParent\r\n")
		_T("PrevDrive\r\n")
		_T("NextDrive\r\n")
		_T("PrevTab\r\n")
		_T("NextTab\r\n")
		_T("PageUp\r\n")
		_T("PageDown\r\n")
		_T("NextNyanFi\r\n")
		_T("PrevNyanFi\r\n"));
	X2BtnFComboBox->Items->Assign(X1BtnFComboBox->Items);

	set_ComboBoxText(WheelBtnVComboBox,
		_T("ZoomReset\r\n")
		_T("TextTop\r\n")
		_T("TextEnd\r\n")
		_T("Close\r\n"));

	set_ComboBoxText(X1BtnVComboBox,
		_T("BackViewHist\r\n")
		_T("PrevFile\r\n")
		_T("NextFile\r\n")
		_T("PageUp\r\n")
		_T("PageDown\r\n")
		_T("NextNyanFi\r\n")
		_T("PrevNyanFi\r\n"));
	X2BtnVComboBox->Items->Assign(X1BtnVComboBox->Items);

	set_ComboBoxText(WheelBtnIComboBox,
		_T("FittedSize\r\n")
		_T("FullScreen\r\n")
		_T("TopFile\r\n")
		_T("EndFile\r\n")
		_T("Close\r\n"));

	set_ComboBoxText(X1BtnIComboBox,
		_T("PrevFile\r\n")
		_T("NextFile\r\n")
		_T("PrevPage\r\n")
		_T("NextPage\r\n")
		_T("Histogram\r\n")
		_T("Loupe\r\n")
		_T("Thumbnail\r\n")
		_T("ThumbnailEx\r\n")
		_T("WarnHighlight\r\n")
		_T("NextNyanFi\r\n")
		_T("PrevNyanFi\r\n"));
	X2BtnIComboBox->Items->Assign(X1BtnIComboBox->Items);

	set_ComboBoxText(MenuCmdComboBox,
		_T("MaskSel      }XNɊYt@CI\r\n")
		_T("MaskDel      }XNɊYt@C폜\r\n")
		_T("MaskCopy     }XNɊYt@CRs[\r\n")
		_T("MaskMove     }XNɊYt@Cړ\r\n")
		_T("MaskPack     }XNɊYt@Ck\r\n")
		_T("ExeCommands  w肵R}hs\r\n"));
	RefMenuPrmBtn->Enabled = false;

	make_KeyList(KeyComboBox->Items);
	make_KeyList(Key2ComboBox->Items);
	Key2ComboBox->Items->Insert(0, EmptyStr);
	Key2ComboBox->Enabled = false;

	make_KeyList(HotKeyComboBox->Items);
	HotKeyComboBox->Items->Insert(0, EmptyStr);
	make_KeyList(AppKeyComboBox->Items);
	AppKeyComboBox->Items->Insert(0, EmptyStr);
	set_ComboBoxText(AppPrmComboBox,
		_T("\r\n")
		_T("FA : ꗗ\r\n")
		_T("FL : `[\r\n")
		_T("FI : INC.T[`\r\n")
		_T("AO : ꗗ̂ݕ\\r\n")
		_T("LO : `[̂ݕ\\r\n")
		_T("LI : `[̂(INC.)\r\n"));

	set_ComboBoxText(OpenByModeComboBox, _T("̂܂\r\nWindows̊֘AtŊJ\r\nW Enter L[\r\n"));

	set_ComboBoxText(DblClickFlComboBox,
		_T("W Enter L[ (OpenStandard)\r\n")
		_T("Windows̊֘AtŊJ (OpenByWin)\r\n")
		_T("Ǝ̊֘AtŊJ (OpenByApp)\r\n"));

	set_ComboBoxText(DefDropComboBox, _T("Windows W\r\nɃRs[\r\nɈړ\r\n"));

	set_ComboBoxText(StdCmdComboBox,
		_T("Windows̊֘AtŊJ (OpenByWin)\r\n")
		_T("Ǝ̊֘AtŊJ (OpenByApp)\r\n")
		_T("eLXgrA[ŊJ (TextViewer)\r\n")
		_T("GfB^ŊJ (FileEdit)\r\n")
		_T("oCiGfB^ŊJ (BinaryEdit)\r\n")
		_T("R}ht@CƂĎs (ExeCommands)\r\n")
		_T("wR}hs (ExeCommands_)\r\n"));

	LayoutChanged  = false;
	inh_KeySet	   = 0;

	UnicodeString hntstr   = LoadUsrMsg(USTR_HintMltSepSC);
	NoWatchPathEdit->Hint  = hntstr;
	NoInfPathEdit->Hint    = hntstr;
	NoImgPrvPathEdit->Hint = hntstr;
	InsHrClsEdit->Hint	   = hntstr;

	hntstr  = LoadUsrMsg(USTR_HintMltFExt);
	ExtColorEdit->Hint	   = hntstr;
	FExtGetInfEdit->Hint   = hntstr;
	FExtNoInfEdit->Hint    = hntstr;
	FExtImgPrvEdit->Hint   = hntstr;
	FExtNoImgPrvEdit->Hint = hntstr;
	FExtImgEdit->Hint	   = hntstr;
	FExtEtcEdit->Hint	   = hntstr;
	ViewTab4Edit->Hint	   = hntstr;
	FExtExeFileEdit->Hint  = hntstr;
	FExtStdEdit->Hint	   = hntstr;

	//Rg[̃^OɁAΉϐ̃|C^ݒ
	//UnicodeString
	L_IniPatEdit->Tag			= (int)&InitialPath[0];
	R_IniPatEdit->Tag			= (int)&InitialPath[1];
	TextEditorEdit->Tag 		= (int)&TextEditor;
	TextEditorFrmtEdit->Tag 	= (int)&TextEditorFrmt;
	ExtTxViewerEdit->Tag		= (int)&ExtTxViewer;
	ExtTxViewerFmtEdit->Tag 	= (int)&ExtTxViewerFrmt;
	ImageEditorEdit->Tag		= (int)&ImageEditor;
	FExtImgEdit->Tag			= (int)&FExtImgEidt;
	BinaryEditorEdit->Tag		= (int)&BinaryEditor;
	SndWarnEdit->Tag			= (int)&SoundWarning;
	SndTaskFinEdit->Tag 		= (int)&SoundTaskFin;
	SndFindFinEdit->Tag 		= (int)&SoundFindFin;
	SndWatchEdit->Tag			= (int)&SoundWatch;
	DirBraEdit->Tag 			= (int)&DirBraStr;
	DirKetEdit->Tag 			= (int)&DirKetStr;
	DrvInfFmtREdit->Tag 		= (int)&DrvInfFmtR;
	DrvInfFmtSEdit->Tag 		= (int)&DrvInfFmtS;
	DrvInfFmtNEdit->Tag 		= (int)&DrvInfFmtN;
	SttBarFmtEdit->Tag			= (int)&SttBarFmt;
	ClockFmtEdit->Tag			= (int)&SttClockFmt;
	TmStampFmtEdit->Tag 		= (int)&TimeStampFmt;
	ViewTab4Edit->Tag			= (int)&FExtViewTab4;
	EmpBin1Edit->Tag			= (int)&EmpBinPtn1;
	EmpBin2Edit->Tag			= (int)&EmpBinPtn2;
	EmpBin3Edit->Tag			= (int)&EmpBinPtn3;
	InsHrClsEdit->Tag			= (int)&HtmInsHrCls;
	HdrStrEdit->Tag				= (int)&HtmHdrStr;
	FExtGetInfEdit->Tag 		= (int)&FExtGetInf;
	FExtNoInfEdit->Tag			= (int)&FExtNoInf;
	NoWatchPathEdit->Tag		= (int)&NoWatchPath;
	NoInfPathEdit->Tag			= (int)&NoInfPath;
	NoImgPrvPathEdit->Tag		= (int)&NoImgPrvPath;
	FExtImgPrvEdit->Tag 		= (int)&FExtImgPrv;
	FExtNoImgPrvEdit->Tag		= (int)&FExtNoImgPrv;
	AutoRenFmtEdit->Tag			= (int)&AutoRenFmt;
	FExtExeFileEdit->Tag		= (int)&FExtExeFile;
	HomeWorkListEdit->Tag		= (int)&HomeWorkList;
	WebSeaUrlEdit->Tag			= (int)&WebSeaUrl;
	BgImg1Edit->Tag				= (int)&BgImgName[0];
	BgImg2Edit->Tag				= (int)&BgImgName[1];
	SpImgEdit->Tag				= (int)&BgImgName[2];
	SpImg2Edit->Tag				= (int)&BgImgName[3];
	KnobImgEdit->Tag			= (int)&BgImgName[4];
	TimerCnd1Edit->Tag			= (int)&Timer_Condition[0];
	TimerCmd1Edit->Tag			= (int)&OnTimerEvent[0];
	TimerCnd2Edit->Tag			= (int)&Timer_Condition[1];
	TimerCmd2Edit->Tag			= (int)&OnTimerEvent[1];

	//int (NumbersOnly = true)
	BatLowLimitEdit->Tag		= (int)&BatLowerLimit;
	MaxLogLinesEdit->Tag		= (int)&MaxLogLines;
	MaxLogFilesEdit->Tag		= (int)&MaxLogFiles;
	FwCntWarnEdit->Tag			= (int)&FlashCntWarning;
	FwTmWarnEdit->Tag			= (int)&FlashTimeWarning;
	FwCntTaskFinEdit->Tag		= (int)&FlashCntTaskfin;
	FwTmTaskFinEdit->Tag		= (int)&FlashTimeTaskfin;
	NotifyTaskTimeEdit->Tag		= (int)&NotifyTaskTime;
	FrmMgnEdit->Tag				= (int)&ImgFrameMargin;
	FitMaxZoomEdit->Tag			= (int)&ImgFitMaxZoom;
	MinShowTimeEdit->Tag		= (int)&MinShowTime;
	IniWinLeftEdit->Tag			= (int)&IniWinLeft;
	IniWinTopEdit->Tag			= (int)&IniWinTop;
	MsgHintTimeEdit->Tag		= (int)&MsgHintTime;
	KeyHintTimeEdit->Tag		= (int)&KeyHintTime;
	ImgGridHEdit->Tag			= (int)&ImgGridHorzN;
	ImgGridVEdit->Tag			= (int)&ImgGridVertN;
	ThumbSizeEdit->Tag	 		= (int)&ThumbnailSize;
	ThumbBdrEdit->Tag			= (int)&ThumbBdrWidth;
	IntrPgEdit->Tag				= (int)&ImgDblMargin;
	BdrMovWdLabeledEdit->Tag	= (int)&BorderMoveWidth;
	ListInterLnEdit->Tag		= (int)&ListInterLn;
	CursorWidthEdit->Tag		= (int)&CursorWidth;
	CursorAlphaEdit->Tag		= (int)&CursorAlpha;
	ListPercentEdit->Tag		= (int)&ListPercent;
	TabWidthEdit->Tag			= (int)&FlTabWidth;
	TextInterLnEdit->Tag		= (int)&ViewTxtInterLn;
	LeftMarginEdit->Tag 		= (int)&ViewLeftMargin;
	FoldWdEdit->Tag 			= (int)&ViewFoldWidth;
	FixedLimitEdit->Tag			= (int)&ViewFixedLimit;
	ViewWheelScrLnEdit->Tag 	= (int)&ViewWhellScrLn;
	ListWheelScrLnEdit->Tag 	= (int)&ListWhellScrLn;
	PrvTxtInfLnEdit->Tag		= (int)&PrvTxtInfLn;
	PrvTxtTailLnEdit->Tag		= (int)&PrvTxtTailLn;
	WatchIntervalEdit->Tag		= (int)&WatchInterval;
	LimitSndEdit->Tag			= (int)&PlaySndLimitTime;
	LogIntervalEdit->Tag		= (int)&LogInterval;
	IniWinWdEdit->Tag			= (int)&IniWinWidth;
	IniWinHiEdit->Tag			= (int)&IniWinHeight;
	DlgMoveEdit->Tag			= (int)&DlgMovePrm;
	DlgSizeEdit->Tag			= (int)&DlgSizePrm;
	CmpDelOwCntEdit->Tag		= (int)&CmpDelOwCnt;
	ToleranceEdit->Tag 			= (int)&TimeTolerance;
	RemoteWaitTimeEdit->Tag 	= (int)&RemoteWaitTime;
	NormalWaitTimeEdit->Tag 	= (int)&NormalWaitTime;
	NopDtctTimeEdit->Tag		= (int)&NopDtctTime;
	ModalAlphaEdit->Tag 		= (int)&ModalScrAlpha;
	BgColAlphaEdit->Tag 		= (int)&BgColAlpha;
	HideTimeEdit->Tag			= (int)&BgHideTime;
	TileIfSzEdit->Tag			= (int)&BgTileSize;
	SplitWidthEdit->Tag 		= (int)&SplitterWidth;
	SplitWidth2Edit->Tag 		= (int)&SplitterWidth2;
	IconCacheEdit->Tag			= (int)&IconCache;

	//bool
	DivFlistUDCheckBox->Tag 	= (int)&DivFileListUD;
	DivDirInfUDCheckBox->Tag	= (int)&DivDirInfUD;
	HideAtrCheckBox->Tag		= (int)&ShowHideAtr;
	SysAtrCheckBox->Tag 		= (int)&ShowSystemAtr;
	DispRegNameCheckBox->Tag	= (int)&DispRegName;
	UncToNetDriveCheckBox->Tag	= (int)&UncToNetDrive;
	PathInTitleBarCheckBox->Tag = (int)&PathInTitleBar;
	UseIndIconCheckBox->Tag 	= (int)&UseIndIcon;
	OmitEndOfNameCheckBox->Tag	= (int)&OmitEndOfName;
	DirJumboCheckBox->Tag		= (int)&ShowDirJumboIco;
	AniGifCheckBox->Tag 		= (int)&PreviewAniGif;
	PrevTxtToInfCheckBox->Tag	= (int)&ShowTextPreview;
	PrevTailCheckBox->Tag		= (int)&ShowTailPreview;
	ViewArcInfCheckBox->Tag 	= (int)&ViewArcInf;
	ReloadActCheckBox->Tag		= (int)&ReloadOnActive;
	OpenAddDrvCheckBox->Tag 	= (int)&OpenAddedDrive;
	CheckUncCheckBox->Tag		= (int)&CheckUnc;
	ForceDelCheckBox->Tag		= (int)&ForceDel;
	RemoveCdRoCheckBox->Tag 	= (int)&RemoveCdReadOnly;
	CopyNoBuffCheckBox->Tag 	= (int)&CopyNoBuffering;
	ShowArcCopyPrgCheckBox->Tag = (int)&ShowArcCopyProg;
	DelUseTrsCheckBox->Tag		= (int)&DelUseTrash;
	NotShowNoTaskCheckBox->Tag	= (int)&NotShowNoTask;
	ShowMsgHintCheckBox->Tag	= (int)&ShowMsgHint;
	ShowKeyHintCheckBox->Tag	= (int)&ShowKeyHint;
	ShowNoKeyHintCheckBox->Tag	= (int)&ShowNoKeyHint;
	ShowCopyHintCheckBox->Tag	= (int)&ShowCopyHint;
	ShowDuplNotifyCheckBox->Tag = (int)&ShowDuplNotify;
	LogErrOnlyCheckBox->Tag 	= (int)&LogErrOnly;
	LogErrMsgCheckBox->Tag		= (int)&LogErrMsg;
	LogHideSkipCheckBox->Tag	= (int)&LogHideSkip;
	LogFullPathCheckBox->Tag	= (int)&LogFullPath;
	SaveLogCheckBox->Tag		= (int)&SaveLog;
	AppendLogCheckBox->Tag		= (int)&AppendLog;
	NotSortWLCheckBox->Tag		= (int)&NotSortWorkList;
	SaveWlUtf8CheckBox->Tag 	= (int)&SaveWorkListUtf8;
	DirHistCsrPosCheckBox->Tag	= (int)&DirHistCsrPos;
	DelDplDirHistCheckBox->Tag	= (int)&DelDplDirHist;
	WorkToDirHistCheckBox->Tag  = (int)&WorkToDirHist;
	NoChkDirHistCheckBox->Tag	= (int)&NoCheckDirHist;
	LoopFlCsrCheckBox->Tag		= (int)&LoopFilerCursor;
	FlCsrVisiCheckBox->Tag		= (int)&FlCursorVisible;
	AutoCompCheckBox->Tag		= (int)&AutoCompComboBox;
	AutoHotkeyCheckBox->Tag 	= (int)&MenuAutoHotkey;
	EscHelpCheckBox->Tag		= (int)&EscapeHelp;
	SelColDrvInfCheckBox->Tag	= (int)&SelColDrvInf;
	PermitCmdsCheckBox->Tag 	= (int)&PermitDotCmds;
	InheritDotCheckBox->Tag 	= (int)&InheritDotNyan;
	DotPerUserCheckBox->Tag 	= (int)&DotNyanPerUser;
	SelByMouseCheckBox->Tag 	= (int)&SelectByMouse;
	SelBaseOnlyCheckBox->Tag	= (int)&SelectBaseOnly;
	SelIconCheckBox->Tag		= (int)&SelectIconSngl;
	PriFExtColCheckBox->Tag 	= (int)&PriorFExtCol;
	ColOnlyFExtCheckBox->Tag	= (int)&ColorOnlyFExt;
	ShowIconCheckBox->Tag		= (int)&ShowIcon;
	ShowByteSizeCheckBox->Tag	= (int)&ShowByteSize;
	ShowImgPrvCheckBox->Tag 	= (int)&ShowImgPreview;
	ShowFilePropCheckBox->Tag	= (int)&ShowProperty;
	HideScrBarCheckBox->Tag 	= (int)&HideScrBar;
	ShowHeaderCheckBox->Tag 	= (int)&ShowHeader;
	FixListCheckBox->Tag		= (int)&FixListWidth;
	KeepOnResizeCheckBox->Tag	= (int)&KeepOnResize;
	KeepCurListWdCheckBox->Tag	= (int)&KeepCurListWidth;
	NoSpcFExtCheckBox->Tag		= (int)&NoSpaceFExt;
	NoClsTabBtnCheckBox->Tag	= (int)&NoClsTabBtn;
	ShowMainMenuCheckBox->Tag	= (int)&ShowMainMenu;
	HideTitMenuCheckBox->Tag	= (int)&HideTitleMenu;
	FlatInfPanelCheckBox->Tag	= (int)&FlatInfPanel;
	GrayScaleCheckBox->Tag		= (int)&BgImgGray;
	HideScrCheckBox->Tag		= (int)&BgImgHideScr;
	TileIfCheckBox->Tag 		= (int)&BgImgTileIf;
	ModalScrCheckBox->Tag		= (int)&ModalScreen;
	DlgCenterCheckBox->Tag		= (int)&DialogCenter;
	ShowLnNoCheckBox->Tag		= (int)&ShowLineNo;
	ShowLnCsrCheckBox->Tag		= (int)&ShowLineCursor;
	ShowTabCheckBox->Tag		= (int)&ShowTAB;
	ShowCrCheckBox->Tag 		= (int)&ShowCR;
	ShowRulerCheckBox->Tag		= (int)&ShowTextRuler;
	TxtSttIsBtmCheckBox->Tag	= (int)&TxtSttIsBottom;
	AozoraCheckBox->Tag 		= (int)&ChkAozora;
	ClickableUrlCheckBox->Tag	= (int)&ClickableUrl;
	RstViewLnCheckBox->Tag		= (int)&RestoreViewLine;
	TvCsrVisiCheckBox->Tag		= (int)&TvCursorVisible;
	LimitBinCsrCheckBox->Tag	= (int)&LimitBinCsr;
	ColorHintCheckBox->Tag		= (int)&TxtColorHint;
	BinMemMapedCheckBox->Tag	= (int)&BinMemMaped;
	EmRemCheckBox->Tag			= (int)&EmpComment;
	EmStrCheckBox->Tag			= (int)&EmpStrings;
	EmRsvCheckBox->Tag			= (int)&EmpReserved;
	EmSymCheckBox->Tag			= (int)&EmpSymbol;
	EmNumCheckBox->Tag			= (int)&EmpNumeric;
	EmHdlnCheckBox->Tag 		= (int)&EmpHeadline;
	EmRubyCheckBox->Tag 		= (int)&EmpRuby;
	InsHrSctCheckBox->Tag		= (int)&HtmInsHrSct;
	InsHrArtCheckBox->Tag		= (int)&HtmInsHrArt;
	InsHrNavCheckBox->Tag		= (int)&HtmInsHrNav;
	MarkdownCheckBox->Tag		= (int)&ToMarkdown;
	RotViewImgCheckBox->Tag 	= (int)&RotViewImg;
	KeepZoomCheckBox->Tag		= (int)&KeepZoomRatio;
	ThumbNameCheckBox->Tag		= (int)&ShowThumbName;
	ThumbExifCheckBox->Tag		= (int)&ShowThumbExif;
	ThumbFExtCheckBox->Tag		= (int)&ShowThumbFExt;
	NotThumbIfArcCheckBox->Tag	= (int)&NotThumbIfArc;
	LoopCurCheckBox->Tag		= (int)&LoopViewCursor;
	HintTopEndCheckBox->Tag 	= (int)&HintTopEndImg;
	BeepTopEndCheckBox->Tag 	= (int)&BeepTopEndImg;
	ImgSttIsBtmCheckBox->Tag	= (int)&ImgSttIsBottom;
	ToolBarISideCheckBox->Tag	= (int)&ToolBarISide;
	SeekBindDirCheckBox->Tag	= (int)&SeekBindDir;
	SeekSwapNPCheckBox->Tag		= (int)&SeekSwapNxtPrv;
	OneStpInDblCheckBox->Tag	= (int)&OneStepInDblPg;
	HideCsrFullCheckBox->Tag	= (int)&HideCsrInFull;
	ThumbScrCheckBox->Tag		= (int)&ShowThumbScroll;
	UseSpiFirstCheckBox->Tag	= (int)&UseSpiFirst;
	SureCopyCheckBox->Tag		= (int)&SureCopy;
	SureMoveCheckBox->Tag		= (int)&SureMove;
	SureDeleteCheckBox->Tag 	= (int)&SureDelete;
	SureUnPackCheckBox->Tag 	= (int)&SureUnPack;
	SureExecCheckBox->Tag		= (int)&SureExec;
	SureOtherCheckBox->Tag		= (int)&SureOther;
	SureExitCheckBox->Tag		= (int)&SureExit;
	SureCmpDelCheckBox->Tag 	= (int)&SureCmpDel;
	SureCancelCheckBox->Tag 	= (int)&SureCancel;
	WarnPowFailCheckBox->Tag	= (int)&WarnPowerFail;
	WarnLowBatheckBox->Tag		= (int)&WarnLowBattery;
	WarnDisconCheckBox->Tag 	= (int)&WarnDisconnect;

	AppMinCheckBox->Tag			= (int)&AppListChgMin;
	OpenCmdPromptCheckBox->Tag	= (int)&OpenByCmdPrompt;
	OpenDirByStdCheckBox->Tag	= (int)&OpenDirByStd;
	AppOnlyCurCheckBox->Tag 	= (int)&OpenOnlyCurApp;
	WinOnlyCurCheckBox->Tag 	= (int)&OpenOnlyCurWin;
	DowAfterStdCheckBox->Tag	= (int)&DownAfterOpenStd;
	OpnStdResCheckBox->Tag		= (int)&OpenStdOnResList;
	IncSeaCaseCheckBox->Tag 	= (int)&IncSeaCaseSens;
	IncSeaLoopCheckBox->Tag 	= (int)&IncSeaLoop;
	IncSea1ExitCheckBox->Tag	= (int)&IncSeaMatch1Exit;
	LimitRarCheckBox->Tag		= (int)&LimitGetRarInf;
	IniPathToTab1CheckBox->Tag	= (int)&IniPathToTab1;
	IniTabHomeAllCheckBox->Tag	= (int)&IniTabHomeAll;
	SplashCheckBox->Tag 		= (int)&ShowSplash;
	FixWinCheckBox->Tag 		= (int)&FixWinPos;
	IniSeaByNumCheckBox->Tag	= (int)&IniSeaByNum;
	IniSeaBySignCheckBox->Tag	= (int)&IniSeaBySign;
	MulInstCheckBox->Tag		= (int)&MultiInstance;
	CloseOtherCheckBox->Tag 	= (int)&CloseOthers;
	TaskTrayCheckBox->Tag		= (int)&StoreTaskTray;

	//UnicodeString (Style = csDropDown)
	L_IniMaskComboBox->Tag		= (int)&InitialMask[0];
	R_IniMaskComboBox->Tag		= (int)&InitialMask[1];
	WheelCmdF0ComboBox->Tag 	= (int)&WheelCmdF[0];
	WheelCmdF1ComboBox->Tag 	= (int)&WheelCmdF[1];
	WheelCmdF2ComboBox->Tag 	= (int)&WheelCmdF[2];
	WheelCmdF3ComboBox->Tag 	= (int)&WheelCmdF[3];
	WheelCmdV0ComboBox->Tag 	= (int)&WheelCmdV[0];
	WheelCmdV1ComboBox->Tag 	= (int)&WheelCmdV[1];
	WheelCmdV2ComboBox->Tag 	= (int)&WheelCmdV[2];
	WheelCmdV3ComboBox->Tag 	= (int)&WheelCmdV[3];
	WheelCmdI0ComboBox->Tag 	= (int)&WheelCmdI[0];
	WheelCmdI1ComboBox->Tag 	= (int)&WheelCmdI[1];
	WheelCmdI2ComboBox->Tag 	= (int)&WheelCmdI[2];
	WheelCmdI3ComboBox->Tag 	= (int)&WheelCmdI[3];
	WheelBtnF0ComboBox->Tag 	= (int)&WheellBtnCmdF[0];
	WheelBtnF1ComboBox->Tag 	= (int)&WheellBtnCmdF[1];
	WheelBtnF2ComboBox->Tag 	= (int)&WheellBtnCmdF[2];
	WheelBtnF3ComboBox->Tag 	= (int)&WheellBtnCmdF[3];
	WheelBtnVComboBox->Tag		= (int)&WheellBtnCmdV;
	WheelBtnIComboBox->Tag		= (int)&WheellBtnCmdI;
	X1BtnFComboBox->Tag 		= (int)&X1BtnCmdF;
	X2BtnFComboBox->Tag 		= (int)&X2BtnCmdF;
	X1BtnVComboBox->Tag 		= (int)&X1BtnCmdV;
	X2BtnVComboBox->Tag 		= (int)&X2BtnCmdV;
	X1BtnIComboBox->Tag 		= (int)&X1BtnCmdI;
	X2BtnIComboBox->Tag 		= (int)&X2BtnCmdI;

	//int (Style = csDropDownList)
	LayoutComboBox->Tag 		= (int)&LayoutMode;
	SizeFmtComboBox->Tag		= (int)&SizeFormatMode;
	TabStyleComboBox->Tag		= (int)&FlTabStyle;
	ScrBarStyleComboBox->Tag	= (int)&ScrBarStyle;
	BgImgModeComboBox->Tag		= (int)&BgImgMode;
	BgImgSubModeComboBox->Tag	= (int)&BgImgSubMode;

	ScaleOptComboBox->Tag		= (int)&WicScaleOpt;
	OpenByModeComboBox->Tag 	= (int)&OpenByMode;
	DblClickFlComboBox->Tag 	= (int)&DblClickFlMode;
	DefDropComboBox->Tag		= (int)&DefDropMode;
	SizeDecDgtComboBox->Tag 	= (int)&SizeDecDigits;

	IniModeIRadioGroup->Tag 	= (int)&InitialModeI;
	L_IniSortRadioGroup->Tag	= (int)&IniSortMode[0];
	R_IniSortRadioGroup->Tag	= (int)&IniSortMode[1];

	cursor_Default();
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::FormShow(TObject *Sender)
{
	cursor_HourGlass();

	set_ListBoxItemHi(ExtColListBox);
	set_ListBoxItemHi(SpiListBox);
	set_ListBoxItemHi(EtcEditorListBox);
	set_ListBoxItemHi(AssociateListBox);
	set_ListBoxItemHi(ExtMenuListBox);
	set_ListBoxItemHi(ExtToolListBox);
	set_ListBoxItemHi(KeyListBox);
	set_ListBoxItemHi(EventListBox);

	InitializeListHeader(ExtMenuHeader, _T("LvV|GCAX|ݒ"), Font);
	THeaderSections *sp = ExtMenuHeader->Sections;
	sp->Items[0]->Width = IniFile->ReadIntGen(_T("ExtMenuColWidth0"),	200);
	sp->Items[1]->Width = IniFile->ReadIntGen(_T("ExtMenuColWidth1"),	120);
	adjust_HeaderSecWidth(ExtMenuHeader, 2);

	InitializeListHeader(ExtToolHeader, _T("LvV|GCAX|ݒ"), Font);
	sp = ExtToolHeader->Sections;
	sp->Items[0]->Width = IniFile->ReadIntGen(_T("ExtToolColWidth0"),	200);
	sp->Items[1]->Width = IniFile->ReadIntGen(_T("ExtToolColWidth1"),	120);
	adjust_HeaderSecWidth(ExtToolHeader, 2);

	L_IniMaskComboBox->Items->Clear();
	for (int i=0; i<PathMaskList->Count; i++) {
		TStringDynArray itm_buf = get_csv_array(PathMaskList->Strings[i], 3, true);
		if (itm_buf[2].IsEmpty() || USAME_TS(itm_buf[2], "*")) continue;
		UnicodeString lbuf;
		if (!itm_buf[1].IsEmpty()) lbuf.sprintf(_T(":%s:"), itm_buf[1]);
		L_IniMaskComboBox->Items->Add(lbuf + itm_buf[2]);
	}
	R_IniMaskComboBox->Items->Assign(L_IniMaskComboBox->Items);

	FindEdit->Text = EmptyStr;

	HelpContext = PageControl1->ActivePage->HelpContext;

	//^OpăRg[ɒlݒ
	BringOptionByTag(this);

	CopyNoBuffCheckBox->Enabled = is_VistaLater();
	if (!CopyNoBuffCheckBox->Enabled) CopyNoBuffCheckBox->Checked = false;

	//^OpȂݒ
	TempDirEdit->Text	= TempPath;
	MigemoDirEdit->Text	= MigemoPath;
	SusieDirEdit->Text	= SpiDir;
	LimitTxtEdit->Text	= ViewTxtLimitSize/1024;
	LimitBinEdit->Text	= ViewBinLimitSize/1048576;
	LimitRarEdit->Text	= GetInfLimitSize/1048576;
	MaxTasksComboBox->ItemIndex = MaxTasks - 1;
	AppPrmComboBox->ItemIndex	= idx_of_word_i(_T("|FA|FL|FI|AO|LO|LI"), AppListHotPrm);

	ColBufList->Assign(ColorList);
	ModalColorBox->Selected = (TColor)get_ListIntVal(ColBufList, _T("ModalScr"), clBlack);

	EtcEditorListBox->Items->Assign(EtcEditorList);
	ExtColListBox->Items->Assign(ExtColList);
	AssociateListBox->Items->Assign(AssociateList);
	StdCmdListBox->Items->Assign(OpenStdCmdList);

	TCheckListBox *lp = ExtMenuListBox;
	lp->Items->Assign(ExtMenuList);
	for (int i=0; i<lp->Count; i++) lp->Checked[i] = !equal_0(get_csv_item(lp->Items->Strings[i], 4));

	lp = ExtToolListBox;
	lp->Items->Assign(ExtToolList);
	for (int i=0; i<lp->Count; i++) lp->Checked[i] = !equal_0(get_csv_item(lp->Items->Strings[i], 5));

	//L[ꗗ̃wb_ݒ
	InitializeListHeader(KeyHeaderControl, _T("L[|R}h|"), Font);
	TCanvas *cv = KeyListBox->Canvas;
	cv->Font->Assign(KeyListBox->Font);
	set_HeaderSecWidth(KeyHeaderControl, 2, cv->TextWidth("Shift+Ctrl+Alt+Space "), abs(cv->Font->Height) * 20);

	KeySortMode = IniFile->ReadIntGen(_T("OptKeySortMode"),	0);
	KeyFuncList->CustomSort(KeyComp_Key);

	for (int i=0; i<MAX_KEYTABS; i++) {
		KeyListBuf[i]->Clear();
		UnicodeString modstr = GetCmdModeStr(i + 1);
		for (int j=0; j<KeyFuncList->Count; j++){
			UnicodeString lbuf = KeyFuncList->Strings[j];
			if (StartsText(modstr, lbuf)) KeyListBuf[i]->Add(lbuf);
		}
	}

	PageControl1Change(NULL);

	(ViewFoldFitWin? FitFoldRadioBtn : SetFoldRadioBtn)->Checked = true;

	switch (IniPathMode[0]) {
	case 1:  L_IniPatMod1RadioBtn->Checked = true; break;
	case 2:  L_IniPatMod2RadioBtn->Checked = true; break;
	default: L_IniPatMod0RadioBtn->Checked = true;
	}

	switch (IniPathMode[1]) {
	case 1:  R_IniPatMod1RadioBtn->Checked = true; break;
	case 2:  R_IniPatMod2RadioBtn->Checked = true; break;
	default: R_IniPatMod0RadioBtn->Checked = true;
	}

	((IniWorkMode==1)? IniWork1RadioBtn : IniWork0RadioBtn)->Checked = true;
	((IniWinMode==1)?  IniWin1RadioBtn  : IniWin0RadioBtn)->Checked  = true;

	set_MigemoCheckBox(MigemoCheckBox, _T("OptKeyMigemo"));

	UnRegCmdCheckBox->Checked = IniFile->ReadBoolGen(_T("OptUnregCmd"));
	SetCmdCombo();

	AsoSortCheckBox->Checked  = IniFile->ReadBoolGen(_T("OptAsoSort"));

	DlgMoveShiftCheckBox->Checked = ContainsText(DlgMoveShift, KeyStr_Shift);
	DlgMoveCtrlCheckBox->Checked  = ContainsText(DlgMoveShift, KeyStr_Ctrl);
	DlgMoveAltCheckBox->Checked   = ContainsText(DlgMoveShift, KeyStr_Alt);
	DlgSizeShiftCheckBox->Checked = ContainsText(DlgSizeShift, KeyStr_Shift);
	DlgSizeCtrlCheckBox->Checked  = ContainsText(DlgSizeShift, KeyStr_Ctrl);
	DlgSizeAltCheckBox->Checked   = ContainsText(DlgSizeShift, KeyStr_Alt);

	UnicodeString kstr = CallHotKey;
	HotShiftCheckBox->Checked	  = remove_text(kstr, KeyStr_Shift);
	HotCtrlCheckBox->Checked	  = remove_text(kstr, KeyStr_Ctrl);
	HotAltCheckBox->Checked 	  = remove_text(kstr, KeyStr_Alt);
	HotWinCheckBox->Checked 	  = remove_text(kstr, _T("Win+"));
	HotKeyComboBox->ItemIndex	  = HotKeyComboBox->Items->IndexOf(kstr);

	kstr = AppListHotKey;
	AppShiftCheckBox->Checked	  = remove_text(kstr, KeyStr_Shift);
	AppCtrlCheckBox->Checked	  = remove_text(kstr, KeyStr_Ctrl);
	AppAltCheckBox->Checked 	  = remove_text(kstr, KeyStr_Alt);
	AppWinCheckBox->Checked 	  = remove_text(kstr, _T("Win+"));
	AppKeyComboBox->ItemIndex	  = AppKeyComboBox->Items->IndexOf(kstr);

	IniSeaShiftCheckBox->Checked  = ContainsText(IniSeaShift, KeyStr_Shift);
	IniSeaCtrlCheckBox->Checked   = ContainsText(IniSeaShift, KeyStr_Ctrl);
	IniSeaAltCheckBox->Checked	  = ContainsText(IniSeaShift, KeyStr_Alt);

	UpdateSpiListBox();

	//Cxg
	EventListBox->Clear();
	MaxWd_Ev = 0;
	for (int i=0; i<MAX_EVENT_CMD; i++) {
		EventListBox->Items->Add(UnicodeString().sprintf(_T("%s\t%s"), EventCmdList[i].dsc, EventCmdList[i].sp->c_str()));
		MaxWd_Ev = std::max(EventListBox->Canvas->TextWidth(EventCmdList[i].dsc), MaxWd_Ev);
	}
	EventCmdsEdit->Text = EmptyStr;

	LayoutChanged	= false;
	WinSizeChanged	= false;
	TlBarColChanged = false;

	KeyWd = EmptyStr;

	cursor_Default();
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::FormClose(TObject *Sender, TCloseAction &Action)
{
	if (ScrMode==SCMD_FLIST) OptionPageIndex = PageControl1->ActivePageIndex;

	IconImgListP->Clear();
	UserModule->UninitializeListBox();

	THeaderSections *sp = ExtMenuHeader->Sections;
	IniFile->WriteIntGen(_T("ExtMenuColWidth0"),	sp->Items[0]->Width);
	IniFile->WriteIntGen(_T("ExtMenuColWidth1"),	sp->Items[1]->Width);
	sp = ExtToolHeader->Sections;
	IniFile->WriteIntGen(_T("ExtToolColWidth0"),	sp->Items[0]->Width);
	IniFile->WriteIntGen(_T("ExtToolColWidth1"),	sp->Items[1]->Width);

	IniFile->WriteIntGen(_T("OptKeySortMode"),		KeySortMode);
	IniFile->WriteBoolGen(_T("OptKeyMigemo"),		MigemoCheckBox);
	IniFile->WriteBoolGen(_T("OptUnregCmd"),		UnRegCmdCheckBox);
	IniFile->WriteBoolGen(_T("OptAsoSort"),			AsoSortCheckBox);
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::FormDestroy(TObject *Sender)
{
	delete FindMarkList;
	delete ColBufList;

	for (int i=0; i<MAX_KEYTABS; i++) delete KeyListBuf[i];
}

//---------------------------------------------------------------------------
//݂̑ΏۃXg{bNX擾
//---------------------------------------------------------------------------
TCustomListBox* __fastcall TOptionDlg::GetCurListBox()
{
	if (PageControl1->ActivePage==ExtMenuSheet) return ExtMenuListBox;
	if (PageControl1->ActivePage==ExtToolSheet) return ExtToolListBox;
	if (PageControl1->ActivePage==FontColSheet) return ExtColListBox;
	if (PageControl1->ActivePage==EditorSheet)  return EtcEditorListBox;
	if (PageControl1->ActivePage==AssoSheet)    return AssociateListBox;
	if (PageControl1->ActivePage==CommadSheet)  return StdCmdListBox;
												return NULL;
}

//---------------------------------------------------------------------------
UnicodeString __fastcall TOptionDlg::GetCmdModeStr(int idx)
{
	if (idx==0) idx = KeyTabControl->TabIndex + 1;
	return (idx>=1 && idx<=MAX_KEYTABS)? ScrModeIdStr.SubString(idx, 1).UCAT_T(":") : EmptyStr;
}
//---------------------------------------------------------------------------
UnicodeString __fastcall TOptionDlg::GetCmdKeyStr()
{
	UnicodeString kstr = GetCmdModeStr();
	if (SelCheckBox->Checked)   kstr += KeyStr_SELECT;
	if (ShiftCheckBox->Checked) kstr += KeyStr_Shift;
	if (CtrlCheckBox->Checked)  kstr += KeyStr_Ctrl;
	if (AltCheckBox->Checked)   kstr += KeyStr_Alt;
	kstr += KeyComboBox->Text;
	if (!Key2ComboBox->Text.IsEmpty()) kstr.cat_sprintf(_T("~%s"), Key2ComboBox->Text);
	return kstr;
}

//---------------------------------------------------------------------------
//2Xg[NJnL[?
//---------------------------------------------------------------------------
bool __fastcall TOptionDlg::IsFirstCmdKey()
{
	bool res = false;

	UnicodeString key = get_tkn_r(GetCmdKeyStr(), ':');
	if (!contains_s(key, _T('~'))) {
		TStrings *sp = KeyListBox->Items;
		for (int i=0; i<sp->Count; i++) {
			UnicodeString fkey = sp->Names[i];
			if (contains_s(fkey, _T('~'))) {
				fkey = get_tkn_m(fkey, ':', '~');
				if (SameText(key, fkey)) { res = true; break; }
			}
		}
	}

	return res;
}

//---------------------------------------------------------------------------
//^uݒ
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::SetSheet(UnicodeString prm)
{
	int idx = idx_of_word_i(_T("GN|G2|MO|DS|FC|TV|IV|ED|KY|AC|XM|XT|ST|NT|CM|EV"), prm);
	if (idx!=-1)
		PageControl1->ActivePageIndex = idx;
	else {
		if		(ScrMode==SCMD_TVIEW)	PageControl1->ActivePage = TxtViewerSheet;
		else if (ScrMode==SCMD_IVIEW)	PageControl1->ActivePage = ImgViewerSheet;
		else 							PageControl1->ActivePageIndex = OptionPageIndex;
	}
}

//---------------------------------------------------------------------------
//ꎞfBNg̎Q
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::RefTmpDirBtnClick(TObject *Sender)
{
	UnicodeString dnam = ExePath;
	if (UserModule->SelectDirEx(_T("ꎞfBNg"), dnam, true)) TempDirEdit->Text = dnam;
}

//---------------------------------------------------------------------------
//MigemofBNg̎Q
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::RefMigemoBtnClick(TObject *Sender)
{
	UnicodeString dnam = ExePath;
	if (UserModule->SelectDirEx(_T("Migemo fBNg"), dnam, true)) MigemoDirEdit->Text = dnam;
}

//---------------------------------------------------------------------------
//̑̃GfB^ꗗ̕`
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::EtcEditorListBoxDrawItem(TWinControl *Control, int Index,
		TRect &Rect, TOwnerDrawState State)
{
	TListBox *lp = (TListBox*)Control;
	TCanvas  *cv = lp->Canvas;
	cv->Font->Assign(lp->Font);
	int xp = Rect.Left + 4;
	int yp = Rect.Top + get_TopMargin(cv);

	int w_x = 0;
	for (int i=0; i<lp->Count; i++) w_x = std::max(cv->TextWidth(lp->Items->Names[i]), w_x);

	UnicodeString etc_fext = lp->Items->Names[Index];
	UnicodeString etc_edtr = exclude_quot(lp->Items->ValueFromIndex[Index]);

	SetHighlight(cv, State.Contains(odSelected));
	cv->FillRect(Rect);
	cv->TextOut(xp, yp, etc_fext);
	cv->TextOut(xp + w_x + 20, yp, etc_edtr);
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::EtcEditorListBoxClick(TObject *Sender)
{
	TListBox *lp = (TListBox*)Sender;
	int idx = lp->ItemIndex;
	if (idx!=-1) {
		FExtEtcEdit->Text	= lp->Items->Names[idx];
		EtcEditorEdit->Text = exclude_quot(lp->Items->ValueFromIndex[idx]);
	}
}

//---------------------------------------------------------------------------
//GfB^/rA[̎Q
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::RefEditorBtnClick(TObject *Sender)
{
	int tag = ((TComponent*)Sender)->Tag;
	UnicodeString tit = get_word_i_idx(
		_T("eLXgGfB^|C[WGfB^|oCiGfB^|̑̃GfB^|OeLXgrA["), tag);
	UserModule->PrepareOpenDlg(tit.c_str(), F_FILTER_EXE, _T("*.exe"));
	UnicodeString fnam;
	if (UserModule->OpenDlgToStr(fnam)) {
		switch (tag) {
		case 0: TextEditorEdit->Text   = fnam;	break;
		case 1: ImageEditorEdit->Text  = fnam;	break;
		case 2: BinaryEditorEdit->Text = fnam;	break;
		case 3: EtcEditorEdit->Text    = fnam;	break;
		case 4: ExtTxViewerEdit->Text  = fnam;	break;
		}
	}
}

//---------------------------------------------------------------------------
//^XNI̒ʒm̎Q
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::RefSoundBtnClick(TObject *Sender)
{
	int tag = ((TComponent*)Sender)->Tag;

	UnicodeString inidir = def_if_empty(ExtractFileDir(rel_to_absdir((tag==0)? SndWarnEdit->Text : SndTaskFinEdit->Text)), ExePath);
	UserModule->PrepareOpenDlg(_T("TEht@C̎w"), F_FILTER_WAV, NULL, inidir);

	UnicodeString fnam;
	if (UserModule->OpenDlgToStr(fnam, true)) {
		switch (tag) {
		case 0: SndWarnEdit->Text    = fnam;	break;
		case 1: SndTaskFinEdit->Text = fnam;	break;
		case 2: SndFindFinEdit->Text = fnam;	break;
		case 3: SndWatchEdit->Text	 = fnam;	break;
		}
		play_sound(UserModule->OpenDlg->FileName);
	}
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::TestSoundBtnClick(TObject *Sender)
{
	switch (((TComponent*)Sender)->Tag) {
	case 0: play_sound(SndWarnEdit->Text);		break;
	case 1: play_sound(SndTaskFinEdit->Text);	break;
	case 2: play_sound(SndFindFinEdit->Text);	break;
	case 3: play_sound(SndWatchEdit->Text);		break;
	}
}

//---------------------------------------------------------------------------
//CAEgύX
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::LayoutChange(TObject *Sender)
{
	LayoutChanged = true;
}

//---------------------------------------------------------------------------
//wi摜̎Q
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::RefBgImgBtnClick(TObject *Sender)
{
	int tag = ((TComponent*)Sender)->Tag;
	TLabeledEdit *ep = (tag==0)? BgImg1Edit : (tag==1)? BgImg2Edit : (tag==2)? SpImgEdit : SpImg2Edit;
	UserModule->OpenImgDlg->Title = "wi摜̎w";
	UserModule->SetOpenImgFilter(ep->Text);
	UserModule->OpenImgDlg->InitialDir = rel_to_absdir(ExtractFilePath(ep->Text));
	UserModule->OpenImgDlg->FileName   = EmptyStr;
	UserModule->OpenImgDlgToEdit(ep, true);
}
//---------------------------------------------------------------------------
//VvXN[mu摜̎Q
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::ScrBarStyleComboBoxClick(TObject *Sender)
{
	if (ScrBarStyleComboBox->ItemIndex==4) {
		UserModule->OpenImgDlg->Title = "mu摜̎w";
		UserModule->SetOpenImgFilter(KnobImgEdit->Text);
		UserModule->OpenImgDlg->InitialDir = rel_to_absdir(ExtractFilePath(KnobImgEdit->Text));
		UserModule->OpenImgDlg->FileName   = EmptyStr;
		if (!UserModule->OpenImgDlgToEdit(KnobImgEdit, true)) {
			ScrBarStyleComboBox->ItemIndex = 0;
			KnobImgEdit->Text = EmptyStr;
		}
	}
	else
		KnobImgEdit->Text = EmptyStr;
}

//---------------------------------------------------------------------------
//tHg
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::FontComboBoxDrawItem(TWinControl *Control, int Index,
		TRect &Rect, TOwnerDrawState State)
{
	TComboBox *cp = (TComboBox*)Control;
	TCanvas   *cv = cp->Canvas;
	cv->Font->Assign(cp->Font);
	int xp = Rect.Left + 2;
	int yp = Rect.Top + get_TopMargin(cv);
	int fh = abs(cv->Font->Height);

	SetHighlight(cv, State.Contains(odSelected));
	cv->FillRect(Rect);
	cv->TextOut(xp, yp, cp->Items->Strings[Index]);
	xp += fh*10;

	if (Index<FontList->Count) {
		TFont *f = (TFont*)FontList->Objects[Index];
		//TCY
		UnicodeString szstr = f->Size;
		cv->TextOut(xp + get_CharWidth(cv, 2) - cv->TextWidth(szstr), yp, szstr);
		xp += fh*2;
		//O
		cv->Font->Assign(f);
		cv->Font->Size = cp->Font->Size;
		SetHighlight(cv, State.Contains(odSelected));
		yp = Rect.Top + get_TopMargin(cv);
		cv->TextOut(xp, yp, f->Name);
	}
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::RefFontBtnClick(TObject *Sender)
{
	int idx = FontComboBox->ItemIndex;
	if (idx>=0 && idx<FontComboBox->Items->Count && idx<FontList->Count) {
		TFont *f = (TFont*)FontList->Objects[idx];
		UserModule->FontDlg->Options.Clear();
		if (idx==4) UserModule->FontDlg->Options << fdFixedPitchOnly;	//eLXgrA[͓
		if (UserModule->FontDlgToFont(f)) {
			//_CAO
			if (USAME_TI(FontComboBox->Items->Strings[idx], "_CAO")) {
				if (f->Size>10) f->Size = 10;
				Application->DefaultFont->Assign(f);
			}
			//̑
			else FontComboBox->Repaint();
		}
	}
}

//---------------------------------------------------------------------------
//zF
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::OptColListBoxDrawItem(TWinControl *Control, int Index,
		TRect &Rect, TOwnerDrawState State)
{
	draw_ColorListBox((TListBox*)Control, Rect, Index, State, ColBufList);
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::RefColBtnClick(TObject *Sender)
{
	TListBox *lp = (((TButton*)Sender)->Tag==1)? TimColListBox : OptColListBox;
	int idx = lp->ItemIndex;	if (idx==-1) return;

	UnicodeString col_nam = lp->Items->Names[idx];
	UserModule->ColorDlg->Color = (TColor)ColBufList->Values[col_nam].ToIntDef(clBlack);
	if (UserModule->ColorDlg->Execute()) {
		ColBufList->Values[col_nam] = IntToStr(UserModule->ColorDlg->Color);
		lp->Repaint();
		if (contained_wd_i(_T("bgTlBar1|bgTlBar2"), col_nam)) TlBarColChanged = true;
	}
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::ModalColorBoxChange(TObject *Sender)
{
	ColBufList->Values["ModalScr"] = IntToStr(ModalColorBox->Selected);
}

//---------------------------------------------------------------------------
//zF̖
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::DisableColActionExecute(TObject *Sender)
{
	TListBox *lp = OptColListBox;
	if (lp->ItemIndex!=-1) {
		ColBufList->Values[lp->Items->Names[lp->ItemIndex]] = IntToStr(clNone);
		lp->Invalidate();
	}
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::DisableColActionUpdate(TObject *Sender)
{
	TListBox *lp = OptColListBox;
	UnicodeString col_id = (lp->ItemIndex!=-1)? lp->Items->Names[lp->ItemIndex] : EmptyStr;
	((TAction*)Sender)->Enabled = contained_wd_i(_T("fgSelItem|frScrKnob|frmTab|bdrLine|bdrFold|bdrFixed"), col_id);
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::DisableCol2ActionExecute(TObject *Sender)
{
	TListBox *lp = TimColListBox;
	if (lp->ItemIndex!=-1) {
		ColBufList->Values[lp->Items->Names[lp->ItemIndex]] = IntToStr(clNone);
		lp->Invalidate();
	}
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::DisableCol2ActionUpdate(TObject *Sender)
{
	((TAction*)Sender)->Enabled = TimColListBox->ItemIndex!=-1;
}

//---------------------------------------------------------------------------
//X|Cg
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::SpuitImageMouseDown(TObject *Sender, TMouseButton Button,
		TShiftState Shift, int X, int Y)
{
	if (Button!=mbLeft) return;

	TImage *ip = (TImage*)Sender;
	SpuitTag = ip->Tag;
	if (SpuitTag!=2) {
		TListBox *cp = (SpuitTag==1)? TimColListBox : OptColListBox;
		if (cp->ItemIndex==-1) return;
	}

	UserModule->BeginSpuit((SpuitTag==2)? SpuitPanel3 : (SpuitTag==1)? SpuitPanel2 : SpuitPanel, ip);
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::SpuitImageMouseUp(TObject *Sender, TMouseButton Button,
		TShiftState Shift, int X, int Y)
{
	if (UserModule->SpuitEnabled()) {
		TColor col = UserModule->EndSpuit();
		if (SpuitTag==2)
			RefExtColPanel->Color = col;
		else {
			TListBox *lp = (SpuitTag==1)? TimColListBox : OptColListBox;
			if (lp->ItemIndex!=-1) {
				UnicodeString col_nam = lp->Items->Names[lp->ItemIndex];
				ColBufList->Values[col_nam] = IntToStr(col);
				lp->Repaint();
				if (contained_wd_i(_T("bgTlBar1|bgTlBar2"), col_nam)) TlBarColChanged = true;
			}
		}
	}
}
//---------------------------------------------------------------------------
//x
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::ModalAlphaEditChange(TObject *Sender)
{
	TLabeledEdit *ep = (TLabeledEdit*)Sender;
	if (EditToInt(ep, 0)>255) ep->Text = 255;
}

//---------------------------------------------------------------------------
//gqʔzF
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::ExtColListBoxClick(TObject *Sender)
{
	int idx = ExtColListBox->ItemIndex;  if (idx==-1) return;
	UnicodeString lbuf = ExtColListBox->Items->Strings[idx];
	RefExtColPanel->Color = (TColor)split_tkn(lbuf, ',').ToIntDef(clNone);
	ExtColorEdit->Text	  = lbuf;
}

//---------------------------------------------------------------------------
//gqʔzFꗗ̕`
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::ExtColListBoxDrawItem(TWinControl *Control, int Index,
		TRect &Rect, TOwnerDrawState State)
{
	TListBox *lp = (TListBox*)Control;
	TCanvas  *cv = lp->Canvas;
	cv->Font->Assign(lp->Font);
	int xp = Rect.Left + 2;
	int yp = Rect.Top + get_TopMargin(cv);

	UnicodeString lbuf = lp->Items->Strings[Index];
	cv->Font->Color = (TColor)split_tkn(lbuf, ',').ToIntDef(clNone);
	bool is_dot = USAME_TS(lbuf, ".");
	UnicodeString ext = REPLACE_TS(lbuf, ".", " .");
	cv->Brush->Color = col_bgList;

	UnicodeString smpl_str;
	smpl_str.sprintf(_T("%s"), is_dot? _T("hogehoge") : _T("hoge.???"));
	int smpl_wd = cv->TextWidth(smpl_str) + 10;
	TRect rc = Rect;  rc.Right = rc.Left + smpl_wd;
	cv->FillRect(rc);
	cv->TextOut(xp + 4, yp, smpl_str);

	SetHighlight(cv, State.Contains(odSelected));
	rc = Rect;  rc.Left += smpl_wd;  xp += smpl_wd;
	cv->FillRect(rc);
	cv->TextOut(xp + 4, yp, ext);
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::RefExtColBtnClick(TObject *Sender)
{
	UserModule->ColorDlg->Color = RefExtColPanel->Color;
	if (UserModule->ColorDlg->Execute()) RefExtColPanel->Color = UserModule->ColorDlg->Color;
}
//---------------------------------------------------------------------------
//gqʐF̒ǉ
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::AddExtColActionExecute(TObject *Sender)
{
	UnicodeString s;
	s.sprintf(_T("0x%06x,%s"), (int)RefExtColPanel->Color, ExtColorEdit->Text);
	ExtColListBox->Items->Add(s);
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::AddExtColActionUpdate(TObject *Sender)
{
	((TAction*)Sender)->Enabled = !ExtColorEdit->Text.IsEmpty();
}
//---------------------------------------------------------------------------
//gqʐF̕ύX
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::ChgExtColActionExecute(TObject *Sender)
{
	int idx = ExtColListBox->ItemIndex;  if (idx==-1) return;
	UnicodeString s;
	s.sprintf(_T("0x%06x,%s"), (int)RefExtColPanel->Color, ExtColorEdit->Text);
	ExtColListBox->Items->Strings[idx] = s;
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::ChgExtColActionUpdate(TObject *Sender)
{
	((TAction*)Sender)->Enabled = !ExtColorEdit->Text.IsEmpty() && ExtColListBox->ItemIndex!=-1;
}

//---------------------------------------------------------------------------
//Xgł̃L[
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::OptListBoxKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	TControl *cp = (TControl*)Sender;
	UnicodeString KeyStr = get_KeyStr(Key, Shift);

	if (cp==KeyListBox) {
		if (equal_DEL(KeyStr)) DelKeyAction->Execute(); else return;
	}
	else {
		if (equal_DEL(KeyStr)) {
			if (cp==EventListBox) {
				TListBox *lp = (TListBox*)cp;
				int idx = lp->ItemIndex;
				if (idx!=-1) lp->Items->Strings[idx] = get_pre_tab(lp->Items->Strings[idx]).UCAT_T("\t");
			}
			else UserModule->DelListItemAction->Execute();
		}
		else if (!UserModule->ListBoxOpeItem(KeyStr)) return;
	}

	Key = 0;
}

//---------------------------------------------------------------------------
//Susie vOC̃fBNgQ
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::RefSusieDirBtnClick(TObject *Sender)
{
	UnicodeString dnam = ExePath;
	if (UserModule->SelectDirEx(_T("Susie vOC"), dnam, true)) {
		SusieDirEdit->Text = dnam;
		delete SPI;
		SPI = new SpiUnit(rel_to_absdir(SusieDirEdit->Text));
		UpdateSpiListBox();
	}
}
//---------------------------------------------------------------------------
//Suisie vOCꗗXV
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::UpdateSpiListBox()
{
	SpiListBox->Clear();
	for (int i=0; i<SPI->PlgList->Count; i++) {
		spi_info *sp = SPI->PlgList->Items[i];
		SpiListBox->Items->Add(UnicodeString().sprintf(_T("%s \t[%s] %s"),
									ExtractFileName(sp->FileName), sp->VerType, sp->FileType));
	}
}
//---------------------------------------------------------------------------
//Sunis vOC̐ݒ
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::ConfigSpiActionExecute(TObject *Sender)
{
	int idx = SpiListBox->ItemIndex;
	if (idx!=-1) {
		spi_info *sp = SPI->PlgList->Items[idx];
		if (sp->ConfigurationDlg) sp->ConfigurationDlg(this->Handle, 1);
	}
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::ConfigSpiActionUpdate(TObject *Sender)
{
	int idx = SpiListBox->ItemIndex;
	if (idx!=-1) {
		spi_info *sp = SPI->PlgList->Items[idx];
		((TAction*)Sender)->Enabled = (sp->ConfigurationDlg!=NULL);
	}
	else
		((TAction*)Sender)->Enabled = false;
}

//---------------------------------------------------------------------------
//̑̃GfB^̒ǉ
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::AddEtcEditorActionExecute(TObject *Sender)
{
	EtcEditorListBox->Items->Add(
		UnicodeString().cat_sprintf(_T("%s=\"%s\""), FExtEtcEdit->Text.LowerCase(), EtcEditorEdit->Text));
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::AddEtcEditorActionUpdate(TObject *Sender)
{
	((TAction*)Sender)->Enabled = !FExtEtcEdit->Text.IsEmpty() && !EtcEditorEdit->Text.IsEmpty();
}
//---------------------------------------------------------------------------
//̑̃GfB^̕ύX
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::ChgEtcEditorActionExecute(TObject *Sender)
{
	int idx = EtcEditorListBox->ItemIndex;  if (idx==-1) return;
	EtcEditorListBox->Items->Strings[idx] =
		UnicodeString().cat_sprintf(_T("%s=\"%s\""), FExtEtcEdit->Text.LowerCase(), EtcEditorEdit->Text);
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::ChgEtcEditorActionUpdate(TObject *Sender)
{
	((TAction*)Sender)->Enabled = !FExtEtcEdit->Text.IsEmpty() && !EtcEditorEdit->Text.IsEmpty();
}

//---------------------------------------------------------------------------
//GCAXύX𔽉f
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::UpdateAlias(UnicodeString o_name, UnicodeString n_name)
{
	if (SameText(o_name, n_name)) return;

	UnicodeString tmp;
	//L[ݒ
	for (int i=0; i<MAX_KEYTABS; i++) {
		for (int j=0; j<KeyListBuf[i]->Count; j++) {
			UnicodeString vbuf = KeyListBuf[i]->ValueFromIndex[j];
			if (!remove_top_Dollar(vbuf)) continue;
			if (SameText(o_name, vbuf))
				KeyListBuf[i]->ValueFromIndex[j] = tmp.sprintf(_T("$%s"), n_name.c_str());
		}
	}
	//֘At
	TListBox *lp = AssociateListBox;
	for (int i=0; i<lp->Count; i++) {
		UnicodeString vbuf = exclude_quot(lp->Items->ValueFromIndex[i]);
		if (!remove_top_Dollar(vbuf)) continue;
		if (SameText(o_name, vbuf))
			lp->Items->ValueFromIndex[i] = tmp.sprintf(_T("\"$%s\""), n_name.c_str());
	}
}
//---------------------------------------------------------------------------
//GCAXɊ֘AtĂgq擾
//---------------------------------------------------------------------------
UnicodeString __fastcall TOptionDlg::get_AliasInfo(UnicodeString alias)
{
	//L[
	UnicodeString k_inf;
	for (int i=0; i<MAX_KEYTABS && k_inf.IsEmpty(); i++) k_inf = get_Alias_KeyStr(alias, KeyListBuf[i]);

	//֘At
	UnicodeString a_inf;
	TListBox *lp = AssociateListBox;
	for (int i=0; i<lp->Count; i++) {
		UnicodeString fext = lp->Items->Names[i];
		UnicodeString vbuf = exclude_quot(lp->Items->ValueFromIndex[i]);
		if (!remove_top_Dollar(vbuf)) continue;
		if (!SameText(alias, vbuf))   continue;
		a_inf.cat_sprintf(_T(".%s"), fext);
	}

	UnicodeString ret_str = k_inf;
	if (!a_inf.IsEmpty()) {
		if (!ret_str.IsEmpty()) ret_str.UCAT_T(" / ");
		ret_str += a_inf;
	}
	return ret_str;
}

//---------------------------------------------------------------------------
//Oc[
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::ExtToolListBoxClick(TObject *Sender)
{
	TCheckListBox *lp = ExtToolListBox;
	if (lp->Count==0) return;
	if (lp->ItemIndex==-1) lp->ItemIndex = 0;
	int idx = lp->ItemIndex;
	TStringDynArray itm_buf = get_csv_array(lp->Items->Strings[idx], EXTTOOL_CSVITMCNT, true);
	ToolTitEdit->Text	= itm_buf[0];
	ToolExeEdit->Text	= itm_buf[1];
	ToolPrmEdit->Text	= itm_buf[2];
	ToolDirEdit->Text	= itm_buf[3];
	ToolAliasEdit->Text = itm_buf[4];

	ToolAliasLabel->Caption = get_AliasInfo(itm_buf[4]);
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::ToolTitEditChange(TObject *Sender)
{
	if (starts_tchs(_T("-<>"), ToolTitEdit->Text)) {
		ToolExeEdit->Text = EmptyStr;
		ToolPrmEdit->Text = EmptyStr;
		ToolDirEdit->Text = EmptyStr;
		if (starts_tchs(_T("-<"), ToolTitEdit->Text)) {
			ToolTitEdit->Text	= ToolTitEdit->Text.SubString(1, 1);
			ToolAliasEdit->Text = EmptyStr;
		}
	}
}

//---------------------------------------------------------------------------
//Oc[̒ǉEύX
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::ChangeExtToolList(bool add)
{
	TCheckListBox *lp = ExtToolListBox;
	int  idx = lp->ItemIndex;
	bool chk = add? true : (idx!=-1)? lp->Checked[idx] : false;

	UnicodeString lbuf;
	lbuf.sprintf(_T("%s,%s,%s,%s,%s,%s"),
		make_csv_str(ToolTitEdit->Text), make_csv_str(ToolExeEdit->Text),
		make_csv_str(ToolPrmEdit->Text), make_csv_str(ToolDirEdit->Text),
		make_csv_str(ToolAliasEdit->Text), make_csv_str(chk));

	//ǉ
	if (add) {
		lp->Items->Add(lbuf);
		lp->Checked[lp->Count - 1] = true;
	}
	//ύX
	else {
		if (idx==-1) return;
		UnicodeString last_alias = get_csv_item(lp->Items->Strings[idx], 4);
		lp->Items->Strings[idx] = lbuf;
		//GCAXύX𔽉f
		UpdateAlias(last_alias, ToolAliasEdit->Text);
	}
}
//---------------------------------------------------------------------------
//ǉ
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::AddToolActionExecute(TObject *Sender)
{
	ChangeExtToolList(true);
}
//---------------------------------------------------------------------------
//ύX
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::ChgToolActionExecute(TObject *Sender)
{
	ChangeExtToolList(false);
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::ChgToolActionUpdate(TObject *Sender)
{
	bool is_special = starts_tchs(_T("-<>"), ToolTitEdit->Text);
	((TAction*)Sender)->Enabled = is_special || (!ToolTitEdit->Text.IsEmpty() && !ToolExeEdit->Text.IsEmpty());
	ToolAliasEdit->Enabled = !starts_tchs(_T("-<"), ToolTitEdit->Text);
	ToolExeEdit->Enabled   = !is_special;
	ToolPrmEdit->Enabled   = !is_special;
	ToolDirEdit->Enabled   = !is_special;
}

//---------------------------------------------------------------------------
//Oc[̎Q
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::RefExeBtnClick(TObject *Sender)
{
	UserModule->PrepareOpenDlg(_T("Oc["), F_FILTER_EXE);
	UserModule->OpenDlgToEdit(ToolExeEdit);
}
//---------------------------------------------------------------------------
//Oc[p[^̎Q
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::RefToolFmtBtnClick(TObject *Sender)
{
	TPoint p = ExtToolPanel->ClientToScreen(Point(RefToolFmtBtn->Left + 8, RefToolFmtBtn->Top + 8));
	ToolPopupMenu->Popup(p.x, p.y);
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::FrmtItemClick(TObject *Sender)
{
	ToolPrmEdit->SelText = get_tkn(((TMenuItem*)Sender)->Caption, ' ');
}
//---------------------------------------------------------------------------
//Oc[̍ƃfBNg̎Q
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::RefDirBtnClick(TObject *Sender)
{
	UnicodeString dnam = ExePath;
	if (UserModule->SelectDirEx(_T("ƃfBNg"), dnam)) ToolDirEdit->Text = dnam;
}

//---------------------------------------------------------------------------
//ǉj[
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::ExtMenuListBoxClick(TObject *Sender)
{
	TCheckListBox *lp = ExtMenuListBox;
	if (lp->Count==0) return;
	if (lp->ItemIndex==-1) lp->ItemIndex = 0;
	int idx = lp->ItemIndex;

	TStringDynArray itm_buf = get_csv_array(lp->Items->Strings[idx], EXTMENU_CSVITMCNT, true);
	MenuTitEdit->Text = itm_buf[0];
	if (starts_tchs(_T("-<"), MenuTitEdit->Text)) {
		MenuCmdComboBox->ItemIndex = -1;
		MenuPrmEdit->Text		   = EmptyStr;
		MenuAliasLabel->Caption    = EmptyStr;
	}
	else {
		TComboBox *cp = MenuCmdComboBox;
		for (int i=0; i<cp->Items->Count; i++) {
			if (StartsText(UAPP_T(itm_buf[1], " "), cp->Items->Strings[i])) {
				cp->ItemIndex = i;  break;
			}
		}
		MenuPrmEdit->Text		= itm_buf[2];
		MenuAliasEdit->Text 	= itm_buf[3];
		MenuAliasLabel->Caption = get_AliasInfo(itm_buf[3]);
		MenuIconEdit->Text		= itm_buf[5];
	}

	RefMenuPrmBtn->Enabled = USAME_TI(get_tkn(MenuCmdComboBox->Text, ' '), "ExeCommands");
}

//---------------------------------------------------------------------------
void __fastcall TOptionDlg::MenuCmdComboBoxChange(TObject *Sender)
{
	RefMenuPrmBtn->Enabled = USAME_TI(get_tkn(MenuCmdComboBox->Text, ' '), "ExeCommands");
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::MenuTitEditChange(TObject *Sender)
{
	if (starts_tchs(_T("-<>"), MenuTitEdit->Text)) {
		MenuCmdComboBox->ItemIndex = -1;
		MenuPrmEdit->Text	= EmptyStr;
		if (starts_tchs(_T("-<"), MenuTitEdit->Text)) {
			MenuTitEdit->Text	= MenuTitEdit->Text.SubString(1, 1);
			MenuAliasEdit->Text = EmptyStr;
		}
	}
}

//---------------------------------------------------------------------------
//j[ڂ̒ǉEύX
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::ChangeExtMenuList(bool add)
{
	TCheckListBox *lp = ExtMenuListBox;
	int  idx = lp->ItemIndex;
	bool chk = add? true : (idx!=-1)? lp->Checked[idx] : false;

	UnicodeString lbuf;
	lbuf.sprintf(_T("%s,%s,%s,%s,%s,%s"),
		make_csv_str(MenuTitEdit->Text), make_csv_str(get_tkn(MenuCmdComboBox->Text, ' ')),
		make_csv_str(MenuPrmEdit->Text), make_csv_str(MenuAliasEdit->Text),
		make_csv_str(chk), make_csv_str(MenuIconEdit->Text));

	if (add) {
		lp->Items->Add(lbuf);
		lp->Checked[lp->Count - 1] = true;
	}
	else {
		if (idx==-1) return;
		UnicodeString last_alias = get_csv_item(lp->Items->Strings[idx], 3);
		lp->Items->Strings[idx] = lbuf;
		//GCAXύX𔽉f
		UpdateAlias(last_alias, MenuAliasEdit->Text);
	}
}
//---------------------------------------------------------------------------
//ǉ
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::AddMenuActionExecute(TObject *Sender)
{
	ChangeExtMenuList(true);
}
//---------------------------------------------------------------------------
//ύX
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::ChgMenuActionExecute(TObject *Sender)
{
	ChangeExtMenuList(false);
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::ChgMenuActionUpdate(TObject *Sender)
{
	bool is_special = starts_tchs(_T("-<>"), MenuTitEdit->Text);
	((TAction*)Sender)->Enabled = is_special ||
		(!MenuTitEdit->Text.IsEmpty() && !MenuCmdComboBox->Text.IsEmpty() && !MenuPrmEdit->Text.IsEmpty());
	MenuAliasEdit->Enabled   = !starts_tchs(_T("-<"), MenuTitEdit->Text);
	MenuCmdComboBox->Enabled = !is_special;
	MenuPrmEdit->Enabled	 = !is_special;
}

//---------------------------------------------------------------------------
//p[^t@C̎Q
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::RefCmdsBtnClick(TObject *Sender)
{
	UnicodeString subtit;
	if (PageControl1->ActivePage==ExtMenuSheet) {
		if (!MenuTitEdit->Text.IsEmpty()) subtit.sprintf(_T(" - [%s]"), MenuTitEdit->Text);
	}
	else if (PageControl1->ActivePage==EventSheet) {
		int idx = EventListBox->ItemIndex;
		if (idx!=-1) subtit.sprintf(_T(" - [%s]"), get_pre_tab(EventListBox->Items->Strings[idx]));
	}

	UnicodeString cmd;
	if		(PageControl1->ActivePage==ExtMenuSheet) cmd = get_CmdStr(MenuPrmEdit->Text);
	else if (PageControl1->ActivePage==EventSheet)	 cmd = get_CmdStr(EventCmdsEdit->Text);

	//ʏt@C̑I
	if (contained_wd_i(_T("ContextMenu|ExeMenuFile|FileEdit|LoadWorkList|OpenByApp|OpenByWin|TextViewer"), cmd)) {
		UnicodeString tit = "p[^̎w" + subtit;
		UserModule->PrepareOpenDlg(tit.c_str(), _T("*.*"), NULL, RefParamPath);
		UnicodeString fnam;
		if (UserModule->OpenDlgToStr(fnam)) {
			RefParamPath = ExtractFilePath(fnam);
			if (contained_wd_i(_T("ContextMenu|ExeMenuFile|LoadWorkList"), cmd))
				fnam = to_relative_name(fnam);
			else if (remove_top_text(fnam, ExePath))
				fnam.Insert("%ExePath%", 1);
			cmd.cat_sprintf(_T("_\"%s\""), fnam);

			if (PageControl1->ActivePage==ExtMenuSheet)
				MenuPrmEdit->Text = cmd;
			else if (PageControl1->ActivePage==EventSheet) {
				EventCmdsEdit->Text = cmd;
				int idx = EventListBox->ItemIndex;
				if (idx!=-1)
					EventListBox->Items->Strings[idx] = get_pre_tab(EventListBox->Items->Strings[idx]) + "\t" + cmd;
			}
		}
	}
	//R}ht@C̑I
	else if (CmdFileListDlg->ShowToSelect()==mrOk) {
		UnicodeString fnam = CmdFileListDlg->CmdFileName;
		fnam = "@" + to_relative_name(fnam);
		if (PageControl1->ActivePage==ExtMenuSheet)
			MenuPrmEdit->Text = fnam;
		else if (PageControl1->ActivePage==EventSheet) {
			switch (((TComponent*)Sender)->Tag) {
			case 100:
				EventCmdsEdit->Text = fnam;
				if (EventListBox->ItemIndex!=-1)
					EventListBox->Items->Strings[EventListBox->ItemIndex]
						 = get_pre_tab(EventListBox->Items->Strings[EventListBox->ItemIndex]) + "\t" + fnam;
				break;
			case 101: TimerCmd1Edit->Text = fnam;	break;
			case 102: TimerCmd2Edit->Text = fnam;	break;
			}
		}
	}
}
//---------------------------------------------------------------------------
//ACR̎Q
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::RefMenuIconBtnClick(TObject *Sender)
{
	UserModule->PrepareOpenDlg(_T("ACR̎w"), F_FILTER_ICO, NULL, IconFilePath);
	if (UserModule->OpenDlgToEdit(MenuIconEdit, true)) IconFilePath = ExtractFilePath(rel_to_absdir(MenuIconEdit->Text));
}

//---------------------------------------------------------------------------
//֘At
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::AssociateListBoxClick(TObject *Sender)
{
	int idx = AssociateListBox->ItemIndex;  if (idx==-1) return;
	AsoExtEdit->Text = AssociateListBox->Items->Names[idx];
	AsoAppEdit->Text = exclude_quot(AssociateListBox->Items->ValueFromIndex[idx]);
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::AssociateListBoxMouseUp(TObject *Sender, TMouseButton Button,
		TShiftState Shift, int X, int Y)
{
	if (Button!=mbRight) return;
	int idx = AssociateListBox->ItemIndex;  if (idx==-1) return;

	TStringDynArray app_lst = get_AssociatedApps(AssociateListBox->Items->Names[idx]);
	if (app_lst.Length>1) {
		std::unique_ptr<TStringList> m_lst(new TStringList());
		make_AssoMenuList(app_lst, m_lst.get());
		//eXgj[쐬
		TestPopupMenu->Items->Clear();
		TestPopupMenu->AutoHotkeys = AutoHotkeyCheckBox->Checked? maAutomatic : maManual;
		IconImgListP->Clear();
		for (int i=0; i<m_lst->Count; i++) {
			TStringDynArray m_buf = split_strings_tab(Trim(m_lst->Strings[i]));
			if (m_buf.Length>0) {
				TMenuItem *mp  = new TMenuItem(TestPopupMenu);
				mp->Caption    = m_buf[0];
				mp->ImageIndex = (m_buf.Length==3)? add_IconImage(m_buf[2], IconImgListP) : -1;
				TestPopupMenu->Items->Add(mp);
			}
		}
		//eXgj[\
		TestPopupMenu->Popup(Mouse->CursorPos.x, Mouse->CursorPos.y);
	}
}

//---------------------------------------------------------------------------
//֘Atꗗ̃\[g (gq͂̂܂)
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::SortAssoListBox(UnicodeString item)
{
	TListBox *lp = AssociateListBox;
	if (lp->Count<2) return;

	std::unique_ptr<TStringList> x_lst(new TStringList());
	for (int i=0; i<lp->Count; i++) {
		UnicodeString lbuf = lp->Items->Strings[i];
		UnicodeString fext = lp->Items->Names[i];
		TStringList *o_lst;
		int idx = x_lst->IndexOf(fext);
		if (idx==-1) {
			o_lst = new TStringList();
			x_lst->AddObject(fext, (TObject*)o_lst);
		}
		else
			o_lst = (TStringList*)x_lst->Objects[idx];
		o_lst->Add(lbuf);
	}
	x_lst->Sort();

	lp->Clear();
	for (int i=0; i<x_lst->Count; i++) {
		TStringList *o_lst = (TStringList*)x_lst->Objects[i];
		for (int j=0; j<o_lst->Count; j++) lp->Items->Add(o_lst->Strings[j]);
		delete o_lst;
	}

	if (!item.IsEmpty()) {
		int idx = lp->Items->IndexOf(item);
		if (idx!=-1) lp->ItemIndex = idx;
	}
}

//---------------------------------------------------------------------------
//֘Atڂ̒ǉEύX
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::ChangeAssociateList(bool add)
{
	if (AsoExtEdit->Text.IsEmpty() || AsoAppEdit->Text.IsEmpty()) return;

	UnicodeString s = AsoExtEdit->Text.LowerCase();
	remove_top_s(s, '.');
	s.cat_sprintf(_T("=\"%s\""), AsoAppEdit->Text);

	//ǉ
	if (add) {
		AssociateListBox->Items->Add(s);
		if (AsoSortCheckBox->Checked) SortAssoListBox(s);
	}
	//ύX
	else {
		if (AssociateListBox->ItemIndex==-1) return;
		AssociateListBox->Items->Strings[AssociateListBox->ItemIndex] = s;
		if (AsoSortCheckBox->Checked) SortAssoListBox(s);
	}
}
//---------------------------------------------------------------------------
//ǉ
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::AddAssoActionExecute(TObject *Sender)
{
	ChangeAssociateList(true);
}
//---------------------------------------------------------------------------
//ύX
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::ChgAssoActionExecute(TObject *Sender)
{
	ChangeAssociateList(false);
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::ChgAssoActionUpdate(TObject *Sender)
{
	((TAction*)Sender)->Enabled = !AsoExtEdit->Text.IsEmpty() && !AsoAppEdit->Text.IsEmpty();
}

//---------------------------------------------------------------------------
//֘Atst@C̑I
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::AsoRefBtnClick(TObject *Sender)
{
	UserModule->PrepareOpenDlg(_T("֘At"), F_FILTER_EXE _T("|") F_FILTER_NBT);
	UnicodeString fnam;
	if (UserModule->OpenDlgToStr(fnam)) {
		if (test_NbtExt(ExtractFileExt(fnam))) fnam = "@" + to_relative_name(fnam);
		AsoAppEdit->Text = fnam;
	}
}

//---------------------------------------------------------------------------
//ꗗ̕`
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::OptListBoxDrawItem(TWinControl *Control, int Index,
		TRect &Rect, TOwnerDrawState State)
{
	TListBox *lp = (TListBox*)Control;
	TCanvas  *cv = lp->Canvas;
	cv->Font->Assign(lp->Font);

	if (lp==EventListBox && USAME_TI(EventCmdList[Index].key, "OnNewDrive") && !State.Contains(odSelected)) {
		cv->Brush->Color = !OpenAddDrvCheckBox->Checked? col_Invalid : scl_Window;
		cv->Font->Color  = scl_WindowText;
	}
	else
		SetHighlight(cv, State.Contains(odSelected));
	cv->FillRect(Rect);

	int xp = Rect.Left + 2;
	int yp = Rect.Top + get_TopMargin(cv);
	UnicodeString lbuf = lp->Items->Strings[Index];
	bool brk = false;

	//SPI
	if (lp==SpiListBox) {
		int w_x = 0;
		for (int i=0; i<lp->Count; i++)
			w_x = std::max(cv->TextWidth(get_pre_tab(lp->Items->Strings[i])), w_x);
		cv->TextOut(xp, yp, split_pre_tab(lbuf));
		cv->TextOut(xp + w_x + 20, yp, lbuf);
		if (Index>0) {
			UnicodeString vt   = lbuf.SubString(1, 4);
			UnicodeString u_vt = get_post_tab(lp->Items->Strings[Index - 1]).SubString(1, 4);
			brk = !SameText(vt, u_vt);
		}
	}
	//Cxg
	else if (lp==EventListBox) {
		UnicodeString tmp = split_pre_tab(lbuf);
		brk = remove_top_s(tmp, '|');
		cv->TextOut(xp, yp, tmp);
		cv->TextOut(xp + MaxWd_Ev + 20, yp, lbuf);
	}
	//֘At
	else {
		int w_x = 0;
		UnicodeString u_fext;
		bool mlt = false;
		for (int i=0; i<lp->Count; i++) {
			UnicodeString fext = lp->Items->Names[i];
			w_x = std::max(cv->TextWidth(fext), w_x);
			if (SameText(fext, u_fext))	mlt = true;
			else if (i>0 && i==Index)	brk = true;
			u_fext = fext;
		}
		if (!mlt) brk = false;
		cv->TextOut(xp, yp, split_tkn(lbuf, '='));
		cv->TextOut(xp + w_x + 20, yp, exclude_quot(lbuf));
	}

	//E
	if (brk) draw_separateLine(cv, Rect);
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::OptMenuListBoxDrawItem(TWinControl *Control, int Index,
		TRect &Rect, TOwnerDrawState State)
{
	TCheckListBox *lp = (TCheckListBox*)Control;
	bool is_tool = (lp==ExtToolListBox);
	THeaderSections *sp = ((THeaderControl *)(is_tool? ExtToolHeader : ExtMenuHeader))->Sections;

	TCanvas *cv  = lp->Canvas;
	cv->Font->Assign(lp->Font);
	SetHighlight(cv, State.Contains(odSelected));
	cv->FillRect(Rect);

	//ڂ̊Kw𒲂ׂ
	int sub_lvl = 0;
	for (int i=0; i<=Index; i++) {
		UnicodeString itm = get_csv_item(lp->Items->Strings[i], 0);
		if (i<Index && USTARTS_TS('>', itm)) sub_lvl++;
		else if (USAME_TS(itm, "<") && sub_lvl>0) sub_lvl--;
	}

	int xp = Rect.Left + 2 + ScaledInt(18) + (sub_lvl * cv->TextWidth("W"));
	int yp = Rect.Top + get_TopMargin(cv);

	UnicodeString lbuf = lp->Items->Strings[Index];
	TStringDynArray itm_buf = get_csv_array(lbuf, (is_tool? EXTTOOL_CSVITMCNT : EXTMENU_CSVITMCNT), true);
	//Zp[^
	if (is_separator(itm_buf[0])) {
		TRect rc = Rect;  rc.Left = xp - 4;
		draw_Separator(cv, rc);
	}
	//
	else {
		//ACR
		usr_SH->draw_SmallIcon(rel_to_absdir(itm_buf[is_tool? 1 : 5]), cv, Rect.Left + 2, yp);
		//LvV
		UnicodeString lbuf = minimize_str(itm_buf[0], cv, sp->Items[0]->Width - xp, true);
		cv->TextOut(xp, yp, lbuf);
		//GCAX
		if (!starts_tchs(_T("-<"), lbuf)) {
			cv->TextOut(sp->Items[0]->Width, yp, minimize_str(itm_buf[is_tool? 4 : 3], cv, sp->Items[1]->Width, true));
		}
		//ݒ
		if (!starts_tchs(_T("-<>"), lbuf)) {
			lbuf = EmptyStr;
			for (int i=1; i<(is_tool? 4 : 3); i++) {
				if (i>1) lbuf.UCAT_T(", ");
				lbuf += itm_buf[i];
			}
			cv->TextOut(sp->Items[0]->Width + sp->Items[1]->Width, yp, lbuf);
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::ExtMenuHeaderSectionResize(THeaderControl *HeaderControl,
          THeaderSection *Section)
{
	ExtMenuListBox->Repaint();
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::ExtToolHeaderSectionResize(THeaderControl *HeaderControl,
          THeaderSection *Section)
{
	ExtToolListBox->Repaint();
}

//---------------------------------------------------------------------------
//L[ݒ
//---------------------------------------------------------------------------
//^u̕`
//e[}pɉ^u`悳Ȃs̑΍
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::KeyTabControlDrawTab(TCustomTabControl *Control, int TabIndex,
		const TRect &Rect, bool Active)
{
	draw_BottomTab(Control, TabIndex, Rect, Active);
}
//---------------------------------------------------------------------------
//JeS[ύX
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::KeyTabControlChanging(TObject *Sender, bool &AllowChange)
{
	KeyListBuf[KeyTabControl->TabIndex]->Assign(KeyListBox->Items);
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::KeyTabControlChange(TObject *Sender)
{
	KeyListBox->Items->Assign(KeyListBuf[KeyTabControl->TabIndex]);

	Key2ComboBox->ItemIndex = -1;
	Key2ComboBox->Enabled	= (KeyTabControl->TabIndex==0 || KeyTabControl->TabIndex==2 || KeyTabControl->TabIndex==3);
	SelCheckBox->Enabled	= (KeyTabControl->TabIndex==0);

	KeyFilterEdit->Text = EmptyStr;
	SortKeyListBox();
	SetCmdCombo();
}

//---------------------------------------------------------------------------
void __fastcall TOptionDlg::KeyHeaderControlDrawSection(THeaderControl *HeaderControl,
		  THeaderSection *Section, const TRect &Rect, bool Pressed)
{
	draw_SortHeader(HeaderControl, Section, Rect, (Section->Index==KeySortMode)? 1 : 0, false, true);
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::KeyHeaderControlSectionClick(THeaderControl *HeaderControl,
		  THeaderSection *Section)
{
	KeySortMode = Section->Index;
	SortKeyListBox();
}

//---------------------------------------------------------------------------
//R}h(CmdComboBox)̍ڂݒ
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::SetCmdCombo(
	UnicodeString kwd)		//tB^ (default = EmptyStr : i荞ݖ)
{
	PrmComboBox->Text	 = EmptyStr;
	PrmComboBox->Enabled = false;

	TStrings *sp = CmdComboBox->Items;
	sp->Clear();
	if (KeyTabControl->TabIndex==-1) return;

	std::unique_ptr<TStringList> cmd_lst(new TStringList());
	UnicodeString modstr = GetCmdModeStr();
	for (int i=0; i<CmdSetList->Count; i++) {
		UnicodeString lbuf = CmdSetList->Strings[i];
		if (StartsText(modstr, lbuf)) cmd_lst->Add(get_tkn_r(lbuf, ':'));
	}
	//ǉj[/Oc[̃GCAX
	if (KeyTabControl->TabIndex==0 || KeyTabControl->TabIndex==2 || KeyTabControl->TabIndex==3) {
		for (int i=0; i<ExtMenuListBox->Count; i++) {
			UnicodeString itm = get_csv_item(ExtMenuListBox->Items->Strings[i], 3);
		 	if (!itm.IsEmpty()) cmd_lst->Add("$" + itm);
		}
		for (int i=0; i<ExtToolListBox->Count; i++) {
			UnicodeString itm = get_csv_item(ExtToolListBox->Items->Strings[i], 4);
		 	if (!itm.IsEmpty()) cmd_lst->Add("$" + itm);
		}
	}

	if (UnRegCmdCheckBox->Checked) {
		TListBox *lp = KeyListBox;
		//o^σR}h𒊏o
		std::unique_ptr<TStringList> reg_lst(new TStringList());
		for (int i=0; i<lp->Items->Count; i++) {
			if (StartsText(modstr, lp->Items->Strings[i])) reg_lst->Add(lp->Items->ValueFromIndex[i]);
		}
		//o^ڂ݂̂c
		int i = 0;
		while (i<cmd_lst->Count) {
			bool found = false;
			for (int j=0; j<reg_lst->Count && !found; j++)
				found = SameText(cmd_lst->Strings[i], get_CmdStr(reg_lst->Strings[j]));
			if (found) cmd_lst->Delete(i); else i++;
		}
		//݈ʒu̍ڂǉ
		int idx = lp->ItemIndex;
		if (idx!=-1) {
			cmd_lst->Add(get_CmdStr(lp->Items->ValueFromIndex[idx]));
			cmd_lst->Sort();
		}
	}

	//tB^
	if (!kwd.IsEmpty()) {
		std::unique_ptr<TStringList> lst(new TStringList());
		lst->Assign(cmd_lst.get());
		UnicodeString ptn = usr_Migemo->GetRegExPtn(MigemoCheckBox->Checked, kwd);
		if (!ptn.IsEmpty()) {
			TRegExOptions opt; opt << roIgnoreCase;
			int i=0;
			while (i<lst->Count) {
				UnicodeString lbuf = get_CmdDesc(lst->Strings[i], false, ExtMenuListBox->Items, ExtToolListBox->Items);
				if (!TRegEx::IsMatch(lbuf, ptn, opt)) lst->Delete(i); else i++;
			}
		}
		cmd_lst->Assign(lst.get());
	}

	//hbv_Eڂ蓖
	for (int i=0; i<cmd_lst->Count; i++)
		sp->Add(get_CmdDesc(cmd_lst->Strings[i], false, ExtMenuListBox->Items, ExtToolListBox->Items));
}

//---------------------------------------------------------------------------
//R}hR{{bNX̕`
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::CmdComboBoxDrawItem(TWinControl *Control, int Index, TRect &Rect,
		TOwnerDrawState State)
{
	TComboBox *cp = (TComboBox*)Control;
	TCanvas   *cv = cp->Canvas;
	int yp = Rect.Top + get_TopMargin(cv);
	int xp = Rect.Left + 4;

	UnicodeString lbuf = cp->Items->Strings[Index];
	UnicodeString cmd  = split_tkn(lbuf, ' ');

	SetHighlight(cv, State.Contains(odSelected));
	cv->FillRect(Rect);
	cv->TextOut(xp, yp, cmd);
	xp += cv->TextHeight("Q")*10;
	cv->TextOut(xp, yp, Trim(lbuf));
}

//---------------------------------------------------------------------------
void __fastcall TOptionDlg::CmdComboBoxChange(TObject *Sender)
{
	UnicodeString cmd = get_tkn(CmdComboBox->Text," ");

	int tab_idx = KeyTabControl->TabIndex;
	UnicodeString params;

	PrmComboBox->Clear();
	PrmComboBox->Style	  = csDropDownList;
	PrmComboBox->Text	  = EmptyStr;
	PrmComboBox->Enabled  = false;
	RefCmdPrmBtn->Enabled = false;

	if (contained_wd_i(
	 	_T("CalcDirSize|CalcDirSizeAll|ChangeDir|ChangeOppDir|Clone|CloneToCurr|ContextMenu|ConvertHtm2Txt|Copy|CopyTo|CountLines|CreateDir|")
		_T("DateSelect|ExeCommands|ExeMenuFile|FileEdit|FTPChmod|Grep|JumpTo|JumpIndex|PropertyDlg|")
		_T("MaskFind|MaskSelect|MatchSelect|ListArchive|ListDuration|ListExpFunc|ListTail|ListText|LoadBgImage|LoadWorkList|MoveTo|")
		_T("NewTextFile|OpenByApp|OpenByExp|OpenByWin|Pack|PackToCurr|PlayList|")
		_T("ScrollUpLog|ScrollUpText|ScrollDownLog|ScrollDownText|")
		_T("SetPathMask|SetSttBarFmt|SetSubSize|ToTab|TextViewer|ImageViewer|ViewTail|WatchTail|")
		_T("WidenCurList|WinPos|CursorUp|CursorDown|FindDown|FindUp|JumpLine|OpenURL|")
		_T("ScrollCursorDown|ScrollCursorUp|ScrollDown|ScrollUp|")
		_T("SetColor|SetMargin|SetTab|SetWidth|SetUserDefStr|SetFontSize"), cmd))
	{
		PrmComboBox->Enabled = true;
		PrmComboBox->Style = USAME_TI(cmd, "ImageViewer")? csDropDownList : csDropDown;
		//t@C/fBNgQƃ{^
		RefCmdPrmBtn->Enabled = contained_wd_i(
			_T("CalcDirSize|CalcDirSizeAll|ChangeDir|ChangeOppDir|ContextMenu|CopyTo|ExeCommands|ExeMenuFile|")
			_T("FileEdit|JumpTo|ListArchive|ListDuration|ListExpFunc|ListTail|ListText|LoadBgImage|LoadWorkList|")
			_T("MoveTo|OpenByApp|OpenByExp|OpenByWin|PropertyDlg|")
			_T("PlayList|TextViewer|SetColor"), cmd);
	}

	//p[^ڂݒ
	if (USAME_TI(cmd, "AlphaBlend")) {
		PrmComboBox->Style = csDropDown;
		params.USET_T("\r\nIN : x\r\n");
	}
	else if (USAME_TI(cmd, "AppList")) {
		params.sprintf(_T("%s"),
			_T("\r\n")
			_T("FA : ꗗɃtH[JX\r\n")
			_T("FL : `[ɃtH[JX\r\n")
			_T("FI : `[ɃtH[JX(INC.T[`)\r\n")
			_T("AO : ꗗ̂ݕ\\r\n")
			_T("LO : `[̂ݕ\\r\n")
			_T("LI : `[̂ݕ\(INC.T[`)\r\n"));
	}
	else if (USAME_TI(cmd, "BgImgMode")) {
		params.sprintf(_T("%s"),
			_T("OFF : \\r\n")
			_T("1 : 2ʂɂ킽ĕ\\r\n")
			_T("2 : ꂼɕ\\r\n")
			_T("3 : fXNgbvwi\\r\n")
			_T("^1 : 2ʂɂ킽ĕ\/\\r\n")
			_T("^2 : ꂼɕ\/\\r\n")
			_T("^3 : fXNgbvwi\/\\r\n"));
	}
	else if (contained_wd_i(_T("CursorUp|CursorDown|ScrollCursorDown|ScrollCursorUp|ScrollDown|ScrollUp"), cmd) && tab_idx!=4) {
		params.USET_T("\r\nHP : y[W\r\nFP : 1y[W\r\n");
	}
	else if (contained_wd_i(_T("CalcDirSize|CalcDirSizeAll"), cmd)) {
		params.sprintf(_T("%s"),
			_T("\r\n")
			_T("LO : ʂOɏo\r\n")
			_T("CC : ʂNbv{[hɃRs[\r\n")
			_T("LS : ʂꗗ\\r\n")
			_T("FC : t@CATufBNg\\r\n"));
		if (USAME_TI(cmd, "CalcDirSizeAll")) {
			params.UCAT_T("SG : Ot\(΃Jg)\r\nDG : Ot\(΃hCu)\r\n");
		}
	}
	else if (USAME_TI(cmd, "ChangeCodePage")) {
		params.sprintf(_T("%s"),
			_T("\r\n")
			_T("932 :   Shift_JIS\r\n")
			_T("50220 : JIS(ISO-2022-JP)\r\n")
			_T("20932 : EUC-JP\r\n")
			_T("1252 :  Latin-1\r\n")
			_T("65001 : UTF-8\r\n")
			_T("1200 :  UTF-16\r\n"));
	}
	else if (contained_wd_i(_T("ChangeDrive|EjectDrive"), cmd)) {
		for (int i=0; i<26; i++) params.cat_sprintf(_T("%c\r\n"), 'A'+i);	//p
		if (USAME_TI(cmd, "EjectDrive")) params.UCAT_T(". : JghCu\r\n");
	}
	else if (contained_wd_i(_T("ChangeRegDir|ChangeOppRegDir"), cmd)) {
		for (int i=0; i<RegDirList->Count; i++) {
			TStringDynArray itm_buf = get_csv_array(RegDirList->Strings[i], 3);
			if (itm_buf.Length!=3 || itm_buf[0].IsEmpty()) continue;
			params.cat_sprintf(_T("%s : %s\r\n"), itm_buf[0].UpperCase(), itm_buf[1]);
		}
	}
	else if (USAME_TI(cmd, "CheckUpdate")) {
		params.USET_T("\r\nNC : ۑꏊ̑IAmFȂ\r\n");
	}
	else if (USAME_TI(cmd, "ClearAll")) {
		params.USET_T("\r\nAL : EׂĂ̑IԂ\r\n");
	}
	else if (USAME_TI(cmd, "ClearMark")) {
		params.USET_T("\r\nAC : ׂĂ̏ꏊׂ̂Ẵ}[N\r\n");
	}
	else if (USAME_TI(cmd, "ClipCopy")) {
		if (tab_idx==2) {
			params.USET_T("\r\nAD : ݂̓eɒǉ\r\n");
		}
		else if (tab_idx==3) {
			params.USET_T("\r\nVI : \ĂԂŃRs[\r\n");
		}
	}
	else if (USAME_TI(cmd, "CompareDlg")) {
		params.USET_T("\r\nNC : _CAOoAÔݔr\r\n");
	}
	else if (contained_wd_i(_T("CompareHash|GetHash"), cmd)) {
		params.sprintf(_T("%s"),
			_T("MD5\r\n")
			_T("SHA1\r\n")
			_T("SHA256\r\n")
			_T("SHA384\r\n")
			_T("SHA512\r\n")
			_T("CRC32\r\n"));
	}
	else if (USAME_TI(cmd, "ConvertHtm2Txt")) {
		params.sprintf(_T("%s"),
			_T("\r\n")
			_T("HD : wb_}\r\n")
			_T("MD : MarkdownL@ɕϊ\r\n")
			_T("TX : ʏeLXgɕϊ\r\n"));
	}
	else if (USAME_TI(cmd, "CopyDir")) {
		params.sprintf(_T("%s"),
			_T("\r\n")
			_T("TO : Rs[\r\n")
			_T("KT : ^CX^vێ\r\n")
			_T("CC : fBNgNbv{[hɃRs[\r\n")
			_T("LS : fBNgꗗ\\r\n"));
	}
	else if (contained_wd_i(_T("CopyFileName|ListFileName"), cmd)) {
		PrmComboBox->Style = csDropDown;
		params.USET_T("\r\nFN : t@Ĉ\r\n");
	}
	else if (contained_wd_i(_T("CurrFromOpp|CurrToOpp"), cmd)) {
		params.USET_T("\r\nSL : IԂ𔽉f\r\n");
	}
	else if (USAME_TI(cmd, "DelJpgExif")) {
		params.USET_T("\r\nKT : ^CX^vێ\r\n");
	}
	else if (USAME_TI(cmd, "DirHistory")) {
		params.sprintf(_T("%s"),
			_T("\r\n")
			_T("AC : Jgׂ̗č폜\r\n")
			_T("GA : S̗\\r\n")
			_T("GS : S̗\(\[g/d폜)\r\n")
			_T("GS : Sׂ̗č폜\r\n"));
	}
	else if (USAME_TI(cmd, "DistributionDlg")) {
		params.sprintf(_T("%s"),
			_T("\r\n")
			_T("XC : mFȂŒɃRs[\r\n")
			_T("XM : mFȂŒɈړ\r\n")
			_T("SN : t@CXg}XNƐUݒ\r\n"));
	}
	else if (USAME_TI(cmd, "Duplicate")) {
		params.USET_T("\r\nRA : Ǘ҂ƂēdN\r\n");
	}
	else if (contained_wd_i(_T("EditHistory|ViewHistory"), cmd)) {
		params.USET_T("\r\nFF : tB^ɃtH[JX\r\nAC : ׂď\r\n");
	}
	else if (USAME_TI(cmd, "Eject")) {
		params.USET_T("\r\n");
		for (int i=0; i<DriveInfoList->Count; i++) {
			drive_info *dp = (drive_info *)DriveInfoList->Objects[i];
			if (dp->drv_type==DRIVE_CDROM)
				params.cat_sprintf(_T("%s\r\n"), get_tkn(dp->drive_str, ':'));
		}
	}
	else if (USAME_TI(cmd, "ExeCommandLine")) {
		params.USET_T("\r\nFN : J[\ʒũt@C\r\n");
	}
	else if (contained_wd_i(_T("ExeExtMenu|ExeExtTool"), cmd)) {
		TStringList *lst= USAME_TI(cmd, "ExeExtMenu")? ExtMenuList : ExtToolList;
		for (int i=0; i<lst->Count; i++) {
			UnicodeString itm = get_csv_item(lst->Strings[i], 0);
			if (!contains_s(itm, _T('&'))) continue;
			UnicodeString ak = get_tkn_r(itm, '&').SubString(1, 1);
			if (ak.IsEmpty() || !_istalnum(ak[1])) continue;
			params.cat_sprintf(_T("%s : %s\r\n"), ak.UpperCase(), itm);
		}
	}
	else if (USAME_TI(cmd, "ExeToolBtn")) {
		TStringList *lst= ToolBtnList;
		for (int i=0; i<lst->Count; i++) {
			TStringDynArray itm_buf = get_csv_array(lst->Strings[i], 2, true);
			if (is_separator(itm_buf[0])) continue;
			params.cat_sprintf(_T("%u : %s\r\n"), i + 1, (!itm_buf[0].IsEmpty()? itm_buf[0] : itm_buf[1]));
		}
	}
	else if (USAME_TI(cmd, "ExtractIcon")) {
		PrmComboBox->Style = csDropDown;
		params.USET_T("\r\nSI : X[ACR𒊏o\r\n");
	}
	else if (USAME_TI(cmd, "Filter")) {
		params.USET_T("\r\nCS : 召\r\n");
	}
	else if (contained_wd_i(_T("FindFileDlg|FindFileDirDlg"), cmd)) {
		params.USET_T("\r\nNM : }XN\\r\nFK : ꗓɃtH[JX\r\n");
	}
	else if (USAME_TI(cmd, "FindMark")) {
		params.USET_T("\r\nAL : ׂẴ}[Nڂ\r\n");
	}

	else if (contained_wd_i(_T("FindSelDown|FindSelUp"), cmd)) {
		params.USET_T("\r\nEM : }b`\\r\n");
	}
	else if (USAME_TI(cmd, "HelpContents")) {
		params.USET_T("\r\nCI : R}h̍\r\nFI : R}h̋@\ʍ\r\nCH : ύX\r\n");
	}
	else if (USAME_TI(cmd, "IncSearch")) {
		params.USET_T("\r\nFM : tB^}XNE[h\r\n");
	}
	else if (USAME_TI(cmd, "InputDir")) {
		params.sprintf(_T("%s"),
			_T("\r\n")
			_T("ND : _CAO\Ȃœ\r\n")
			_T("SD : tH_Qƃ_CAO\\r\n"));
	}
	else if (USAME_TI(cmd, "DriveList")) {
		params.sprintf(_T("%s"),
			_T("\r\n")
			_T("ND : |bvAbvj[őI\r\n")
			_T("NS : |bvAbvj[őI(󂫗eʔ\)\r\n"));
	}
	else if (USAME_TI(cmd, "InputCommands")) {
		params.USET_T("\r\nEL : GR[AR}ht@C̍sԍ\\r\n");
	}
	else if (contained_wd_i(_T("CmdFileList|ListClipboard|MarkList|KeyList|FunctionList|UserDefList"), cmd)) {
		params.USET_T("\r\nFF : tB^ɃtH[JX\r\n");
	}
	else if (contained_wd_i(_T("Exit|Close"), cmd)) {
		params.USET_T("\r\nNS : INIt@CۑȂ\r\nNX : NyanFiIȂ\r\n");
	}
	else if (USAME_TI(cmd, "ExPopupMenu")) {
		params.USET_T("\r\nMN : ǉj[̂ݕ\\r\nTL : Oc[̂ݕ\\r\n");
	}
	else if (USAME_TI(cmd, "Library")) {
		params.USET_T("\r\nSD : I_CAO\\r\n* : Ij[\\r\n");
		std::unique_ptr<TStringList> lst(new TStringList());
		get_files(LibraryPath, _T("*.library-ms"), lst.get());
		for (int i=0; i<lst->Count; i++)
			params.cat_sprintf(_T("%s\r\n"), get_base_name(lst->Strings[i]));
	}
	else if (contained_wd_i(_T("CountLines|ListArchive|ListDuration|ListExpFunc|ListNyanFi"), cmd)) {
		params.USET_T("\r\nCC : ʂNbv{[hɃRs[\r\nLS : ʂꗗ\\r\n");
	}
	else if (USAME_TI(cmd, "ListLog")) {
		params.USET_T("\r\nEO : G[ӏ̍i荞ݕ\\r\n");
	}
	else if (USAME_TI(cmd, "ListTail")) {
		params.USET_T("\r\nTE : ŌɈړr\nFF : tB^ɃtH[JX\r\n");
	}
	else if (USAME_TI(cmd, "ListText")) {
		params.USET_T("\r\nFF : tB^ɃtH[JX\r\nEO : G[ӏ̍i荞ݕ\\r\n");
	}
	else if (USAME_TI(cmd, "Mark") && (tab_idx==0 || tab_idx==3)) {
		params.USET_T("\r\nND : J[\ړȂ\r\nIM : \r\n");
	}
	else if (USAME_TI(cmd, "MoveTab")) {
		params.USET_T("\r\nTP : 擪ɐ擪\r\nED : ŌɈړ\r\nPR : POɈړ\r\n");
	}
	else if (USAME_TI(cmd, "PageBind")) {
		params.USET_T("\r\nR : EԂ\r\nL : Ԃ\r\n");
	}
	else if (USAME_TI(cmd, "NextNyanFi")) {
		params.USET_T("\r\nDN : ȂΓdN\r\n");
	}
	else if (USAME_TI(cmd, "PlayList")) {
		params.sprintf(_T("%s"),
			_T("\r\n")
			_T("RP : s[gĐ\r\n")
			_T("SF : VbtĐ\r\n")
			_T("SR : VbtEs[gĐ\r\n")
			_T("NX : ̋Ȃ\r\n")
			_T("PR : ŐȂ\r\n")
			_T("PS : ꎞ~\r\n")
			_T("RS : ĊJ\r\n")
			_T("FI : t@C\\r\n")
			_T("LS : vCXg\\r\n"));
	}
	else if (contained_wd_i(_T("RegDirDlg|PathMaskDlg"), cmd)) {
		params.USET_T("\r\nND : |bvAbvj[őI\r\n");
	}
	else if (contained_wd_i(_T("RegDirPopup|PushDir|PopDir"), cmd)) {
		params.USET_T("\r\nOP : ΑŎs\r\n");
	}
	else if (USAME_TI(cmd, "ReloadList")) {
		params.USET_T("\r\nCO : JĝݍXV\r\nOFF : XV֎~\r\n");
	}
	else if (USAME_TI(cmd, "Restart")) {
		params.USET_T("\r\nNS : INIt@CۑȂ\r\nRA : Ǘ҂ƂčċN\r\n");
	}
	else if (USAME_TI(cmd, "SaveAsWorkList")) {
		params.USET_T("\r\nFL : Jg̓e[NXgƂĕۑ\r\n");
	}
	else if (contained_wd_i(_T("ScrollUpLog|ScrollUpText|ScrollDownLog|ScrollDownText"), cmd)) {
		params.USET_T("\r\nHP : y[W\r\nFP : 1y[W\r\n");
		params.cat_sprintf(_T("%s\r\n"), contains_i(cmd, _T("Down"))? _T("ED : Ō") : _T("TP : 擪"));
	}
	else if (USAME_TI(cmd, "Select") && (tab_idx==0 || tab_idx==3)) {
		PrmComboBox->Style = csDropDown;
		params.USET_T("\r\n");
		if (tab_idx==0) params.UCAT_T("IN : JԂ񐔂\r\n");
		params.UCAT_T("ND : J[\ړȂ\r\n");
	}
	else if (USAME_TI(cmd, "SelEmptyDir")) {
		params.USET_T("\r\nNF : t@C܂܂ĂȂΑI\r\n");
	}
	else if (contained_wd_i(_T("MarkMask|SelMask"), cmd)) {
		params.USET_T("\r\nCA : }XN\r\n");
	}
	else if (USAME_TI(cmd, "SetColor")) {
		params.USET_T("\r\nRS : zFZbg\r\n");
	}
	else if (USAME_TI(cmd, "SetPathMask")) {
		params.USET_T("\r\nEX : J[\ʒůgqŃ}XN\r\n");
	}
	else if (USAME_TI(cmd, "SetTabIcon")) {
		params.USET_T("\r\nCI : ACR폜\r\n");
	}
	else if (USAME_TI(cmd, "SetTopAddr")) {
		params.sprintf(_T("%s"),
			_T("\r\n")
			_T("TP : 擪AhX擪\r\n")
			_T("NX : 擪AhX㑱\r\n")
			_T("PR : 擪AhXs\r\n")
			_T("ED : I[AhXŌ\r\n"));
	}
	else if (USAME_TI(cmd, "ShowFileInfo")) {
		params.USET_T("\r\nSD : _CAOŕ\\r\n");
	}
	else if (USAME_TI(cmd, "Sort")) {
		params.USET_T("\r\nAO : \r\nDO : ~\r\n");
	}
	else if (USAME_TI(cmd, "SortDlg")) {
		params.sprintf(_T("%s"),
		 	_T("\r\n")
			_T("F : O\r\n")
			_T("E : gq\r\n")
			_T("D : XV\r\n")
			_T("S : TCY\r\n")
			_T("A : \r\n")
			_T("FE : O/gqgO؂ւ\r\n")
			_T("FD : O/XVgO؂ւ\r\n")
			_T("FS : O/TCYgO؂ւ\r\n")
			_T("ED : gq/XVgO؂ւ\r\n")
			_T("ES : gq/TCYgO؂ւ\r\n")
			_T("DS : XV/TCYgO؂ւ\r\n")
			_T("IV : ݂̃\[g@t\r\n")
			_T("IA : ׂẴ\[g@t\r\n"));
	}
	else if (USAME_TI(cmd, "SwapLR")) {
		params.USET_T("\r\nTO : Αֈړ\r\n");
	}
	else if (USAME_TI(cmd, "TabHome")) {
		params.USET_T("\r\nAL : ׂẴ^uɓKp\r\nCO : Jĝ݂ɓKp\r\n");
	}
	else if (contained_wd_i(_T("TextViewer|ImageViewer"), cmd)) {
		params.USET_T("\r\nCB : Nbv{[h̓e\\r\nNN : NyanFiŕ\\r\n");
	}
	else if (USAME_TI(cmd, "ToOppSameItem")) {
		params.USET_T("\r\nNO : ΑֈړȂ\r\n");
	}
	else if (contained_wd_i(_T("ToParent|ToParentOnLeft|ToParentOnRight"), cmd)) {
		params.sprintf(_T("%s"),
			_T("\r\n")
			_T("DL : [gȂhCu/LtH_ꗗ\\r\n")
			_T("DP : [gȂhCuIj[\\r\n"));
	}
	else if (contained_wd_i(_T("UnPack|UnPackToCurr"), cmd)) {
		params.sprintf(_T("%s"),
			_T("\r\n")
			_T("CD : fBNg쐬Ă̒\r\n")
			_T("CD2 : [gɕ̑ΏۂfBNg쐬\r\n"));
	}
	else if (USAME_TI(cmd, "UpdateFromArc")) {
		params.USET_T("\r\nUN : VA[JCuTčXV\r\n");
	}
	else if (USAME_TI(cmd, "WatchTail")) {
		params.sprintf(_T("%s"),
			_T("\r\n")
			_T("ST : Ďe\\r\n")
			_T("CC : J[\ʒut@C̊Ď𒆎~\r\n")
			_T("AC : ׂĂ̊Ď𒆎~\r\n"));
	}
	if (USAME_TI(cmd, "WebMap")) {
		params.USET_T("\r\nIN : ܓx,ox\r\n");
	}
	else if (USAME_TI(cmd, "WebSearch")) {
		params.USET_T("\r\nCB : Nbv{[h̓e\r\n");
		if (tab_idx==0) params.UCAT_T("FN : J[\ʒũt@C\r\n");
	}
	else if (USAME_TI(cmd, "WorkList") && tab_idx==0) {
		params.USET_T("\r\nOP : ΑŎs\r\nRL : ύXejēǂݍݒ\r\n");
	}
	else if (contained_wd_i(_T("ZoomIn|ZoomOut"), cmd)) {
		params.USET_T("\r\n");
		for (int i=2; i<=12; i++) params.cat_sprintf(_T("%u\r\n"), i);
	}
	else if (contained_wd_i(_T("Copy|Move|Delete|CompleteDelete"), cmd)) {
		params.USET_T("\r\nSO : Iڂ̂ݏ\r\n");
		if (contained_wd_i(_T("Copy|Move"), cmd)) params.UCAT_T("OP : Α̃J[\ʒuݒ\r\n");
		if (USAME_TI(cmd, "Copy"))	 params.UCAT_T("TO : Rs[\r\n");
		if (USAME_TI(cmd, "Move"))	 params.UCAT_T("TO : ړ\r\n");
	}
	//gOR}h
	else if (contained_wd_i(
		_T("FileListOnly|HideSizeTime|LockTextPreview|MenuBar|")
		_T("ShowByteSize|ShowHideAtr|ShowIcon|ShowPreview|ShowProperty|ShowStatusBar|ShowSystemAtr|ShowTabBar|")
		_T("PauseAllTask|Suspend|SyncLR|UseTrash|")
		_T("BitmapView|CharInfo|CsvRecord|Highlight|HtmlToText|Inspector|ShowCR|ShowLineNo|ShowRuby|ShowRuler|ShowTAB|FixedLen|")
		_T("DoublePage|FullScreen|GifViewer|GrayScale|Histogram|Loupe|ShowGrid|ShowSeekBar|Sidebar|")
		_T("Thumbnail|ThumbnailEx|WarnHighlight"),
		cmd))
	{
		params.USET_T("\r\nON : \/L\r\nOFF : \//\r\n");
	}
	//IvVݒ
	else if (USAME_TI(cmd, "OptionDlg")) {
		params.sprintf(_T("%s"),
			_T("\r\n")
			_T("GN : \r\n")
			_T("MO : }EX\r\n")
			_T("DS : fUC\r\n")
			_T("TV : eLXgrA[\r\n")
			_T("IV : C[WrA[\r\n")
			_T("ED : GfB^\r\n")
			_T("AC : ֘At\r\n")
			_T("ST : N\r\n")
			_T("XM : ǉj[\r\n")
			_T("XT : Oc[\r\n")
			_T("KY : L[ݒ\r\n")
			_T("NT : ʒmEmFEqg\r\n")
			_T("CM : R}h\r\n")
			_T("EV : Cxg\r\n"));
	}

	if (!params.IsEmpty()) PrmComboBox->Items->Text = params;

	if (PrmComboBox->Items->Count>0) {
		PrmComboBox->Enabled   = true;
		PrmComboBox->ItemIndex = 0;
	}
}

//---------------------------------------------------------------------------
void __fastcall TOptionDlg::UnRegCmdCheckBoxClick(TObject *Sender)
{
	SetCmdCombo();
	KeyListBoxClick(KeyListBox);
}

//---------------------------------------------------------------------------
void __fastcall TOptionDlg::KeyListBoxClick(TObject *Sender)
{
	inh_KeySet++;

	if (!KeyFilterEdit->Text.IsEmpty() || UnRegCmdCheckBox->Checked) {
		KeyFilterEdit->Text = EmptyStr;
		SetCmdCombo();
	}

	TListBox *lp = KeyListBox;
	int idx = lp->ItemIndex;  if (idx==-1) return;
	UnicodeString kstr = get_tkn_r(lp->Items->Names[idx], ':');
	UnicodeString fstr = lp->Items->ValueFromIndex[idx];

	ShiftCheckBox->Checked = remove_text(kstr, KeyStr_Shift);
	CtrlCheckBox->Checked  = remove_text(kstr, KeyStr_Ctrl);
	AltCheckBox->Checked   = remove_text(kstr, KeyStr_Alt);
	SelCheckBox->Checked   = remove_text(kstr, KeyStr_SELECT);

	if (contains_s(kstr, _T('~'))) {
		//2Xg[N
		KeyComboBox->ItemIndex	= KeyComboBox->Items->IndexOf(get_tkn(kstr, '~'));
		Key2ComboBox->ItemIndex = Key2ComboBox->Items->IndexOf(get_tkn_r(kstr, '~'));
	}
	else {
		KeyComboBox->ItemIndex	= KeyComboBox->Items->IndexOf(kstr);
		Key2ComboBox->ItemIndex = 0;
	}

	//R}h
	UnicodeString cmd = fstr;
	UnicodeString prm;
	if (!starts_Dollar(cmd)) {
		prm = get_PrmStr(cmd);
		cmd = get_CmdStr(cmd);
	}

	TComboBox *cp = CmdComboBox;
	for (int i=0; i<cp->Items->Count; i++) {
		if (StartsText(UAPP_T(cmd, " "), cp->Items->Strings[i])) {
			cp->ItemIndex = i;
			CmdComboBoxChange(cp);
			break;
		}
	}

	//p[^
	cp = PrmComboBox;
	if (cp->Enabled) {
		if (cp->Style==csDropDown)
			cp->Text = prm;
		else {
			for (int i=0; i<cp->Items->Count; i++) {
				if (SameText(prm, get_tkn(cp->Items->Strings[i], ' '))) {
					cp->ItemIndex = i; break;
				}
			}
		}
	}

	inh_KeySet--;
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::KeySetClick(TObject *Sender)
{
	if (inh_KeySet>0) return;

	UnicodeString kbuf = GetCmdKeyStr().UCAT_T("=");

	TListBox *lp = KeyListBox;
	int idx = -1;
	for (int i=0; i<lp->Items->Count; i++) {
		if (StartsText(kbuf, lp->Items->Strings[i])) { idx = i;  break; }
	}
	if (idx!=-1) {
		lp->ItemIndex = idx;
		KeyListBoxClick(lp);
	}
}

//---------------------------------------------------------------------------
//tB^
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::KeyFilterEditChange(TObject *Sender)
{
	UnicodeString kwd = ((TEdit*)Sender)->Text;
	cursor_Default();
	set_RedrawOff(CmdComboBox);
	{
		CmdComboBox->DroppedDown = false;
		SetCmdCombo(kwd);
		if (!kwd.IsEmpty()) {
			CmdComboBox->DroppedDown = true;
			CmdComboBox->ItemIndex	 = 0;
		}
	}
	set_RedrawOn(CmdComboBox);
	Screen->Cursor = crArrow;	//hbv_EɃJ[\錻ۂւ̑΍
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::KeyFilterEditKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	UnicodeString KeyStr = get_KeyStr(Key, Shift);

	if (contained_wd_i(KeysStr_CsrDown, KeyStr)) {
		CmdComboBox->SetFocus();
		perform_Key(CmdComboBox, VK_DOWN);
	}
	else if (equal_ENTER(KeyStr)) {
		//m
		if (CmdComboBox->DroppedDown) {
			CmdComboBox->SetFocus();
			perform_Key_RETURN(CmdComboBox);
		}
	}
	else if	(equal_ESC(KeyStr) && !KeyFilterEdit->Text.IsEmpty())
		KeyFilterEdit->Text = EmptyStr;
	else if (SameText(KeyStr, KeyStr_Migemo))
		MigemoCheckBox->Checked = !MigemoCheckBox->Checked;
	else return;

	Key = 0;
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::KeyFilterEditKeyPress(TObject *Sender, System::WideChar &Key)
{
	if (Key==VK_RETURN || Key==VK_ESCAPE) Key = 0;
}

//---------------------------------------------------------------------------
//L[ݒ̌
//---------------------------------------------------------------------------
bool __fastcall TOptionDlg::MatchKeyItem(int idx)
{
	bool found = false;
	TListBox *lp = KeyListBox;
	UnicodeString kwd = FindKeyEdit->Text;
	if (!kwd.IsEmpty() && idx>=0 && idx<lp->Count) {
		UnicodeString dsc = get_CmdDesc(lp->Items->ValueFromIndex[idx],
								false, ExtMenuListBox->Items, ExtToolListBox->Items);
		found = ContainsText(dsc, kwd);
	}
	return found;
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::FindKeyEditChange(TObject *Sender)
{
	TListBox *lp = KeyListBox;
	if (!FindKeyEdit->Text.IsEmpty()) {
		int idx = -1;
		for (int i=0; i<lp->Count && idx==-1; i++) if (MatchKeyItem(i)) idx = i;
		lp->ItemIndex = idx;
		if (idx!=-1) KeyListBoxClick(lp);
	}
	else lp->ItemIndex = -1;
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::FindKeyEditKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	if (!Shift.Empty()) return;

	if		(Key==VK_UP)	{ FindKeyUpAction->Execute();	Key = 0; }
	else if (Key==VK_DOWN)	{ FindKeyDownAction->Execute();	Key = 0; }
}
//---------------------------------------------------------------------------
//Ɍ
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::FindKeyDownActionExecute(TObject *Sender)
{
	TListBox *lp = KeyListBox;
	if (!FindKeyEdit->Text.IsEmpty() && lp->Count>0) {
		int i0 = (lp->ItemIndex!=-1)? lp->ItemIndex : 0;
		if (MatchKeyItem(i0)) i0++;
		int idx = -1;
		for (int i=i0; i<lp->Count && idx==-1; i++) if (MatchKeyItem(i)) idx = i;
		if (idx!=-1) {
			lp->ItemIndex = idx;
			KeyListBoxClick(lp);
		}
		else beep_Warn();
	}
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::FindKeyDownActionUpdate(TObject *Sender)
{
	TListBox *lp = KeyListBox;
	int idx = -1;
	for (int i=lp->Count-1; i>=0 && idx==-1; i--) if (MatchKeyItem(i)) idx = i;
	((TAction*)Sender)->Enabled = (idx!=-1 && idx>lp->ItemIndex);
}
//---------------------------------------------------------------------------
//Ɍ
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::FindKeyUpActionExecute(TObject *Sender)
{
	TListBox *lp = KeyListBox;
	if (!FindKeyEdit->Text.IsEmpty() && lp->ItemIndex>0) {
		int i0 = lp->ItemIndex;
		if (MatchKeyItem(i0)) i0--;
		int idx = -1;
		for (int i=i0; i>=0 && idx==-1; i--) if (MatchKeyItem(i)) idx = i;
		if (idx!=-1) {
			lp->ItemIndex = idx;
			KeyListBoxClick(lp);
		}
		else beep_Warn();
	}
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::FindKeyUpActionUpdate(TObject *Sender)
{
	TListBox *lp = KeyListBox;
	int idx = -1;
	for (int i=0; i<lp->Count && idx==-1; i++) if (MatchKeyItem(i)) idx = i;
	((TAction*)Sender)->Enabled = (idx!=-1 && idx<lp->ItemIndex);
}

//---------------------------------------------------------------------------
//L[ꗗ̕`
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::KeyListBoxDrawItem(TWinControl *Control, int Index, TRect &Rect,
		TOwnerDrawState State)
{
	TListBox *lp = (TListBox*)Control;
	TCanvas  *cv = lp->Canvas;
	cv->Font->Assign(lp->Font);
	int xp = Rect.Left + 2;
	int yp = Rect.Top + get_TopMargin(cv);

	UnicodeString key = get_tkn_r(lp->Items->Names[Index], ':');
	UnicodeString cmd = lp->Items->ValueFromIndex[Index];

	SetHighlight(cv, State.Contains(odSelected));
	cv->FillRect(Rect);

	cv->TextOut(xp, yp, key); xp += cv->TextWidth("Shift+Ctrl+Alt+Space ");
	UnicodeString dsc = get_CmdDesc(cmd, true, ExtMenuListBox->Items, ExtToolListBox->Items);
	int w_cmd = abs(cv->Font->Height) * 20;
	cmd = minimize_str(del_CmdDesc(cmd), cv, w_cmd - 8, true);
	cv->TextOut(xp, yp, cmd);
	xp += w_cmd;
	cv->TextOut(xp, yp, dsc);
}

//---------------------------------------------------------------------------
//L[ꗗ̃\[g
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::SortKeyListBox(UnicodeString item)
{
	TListBox *lp = KeyListBox;
	std::unique_ptr<TStringList> key_lst(new TStringList());
	key_lst->Assign(lp->Items);

	switch (KeySortMode) {
	case  1:	//R}h
		key_lst->CustomSort(KeyComp_Cmd);	break;
	case  2:	//
		cursor_HourGlass();
		key_lst->CustomSort(KeyComp_Dsc);
		cursor_Default();
		break;
	default:	//L[
		key_lst->CustomSort(KeyComp_Key);
	}

	lp->Items->Assign(key_lst.get());
	if (!item.IsEmpty()) {
		int idx = lp->Items->IndexOf(item);
		if (idx!=-1) lp->ItemIndex = idx;
	}

	KeyHeaderControl->Repaint();
}

//---------------------------------------------------------------------------
//L[ݒ̒ǉEύX
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::ChangeKeyList(bool add)
{
	if (KeyComboBox->ItemIndex!=-1 && CmdComboBox->ItemIndex!=-1) {
		try {
			UnicodeString ibuf = GetCmdKeyStr();
			UnicodeString cmd  = get_tkn(CmdComboBox->Text, ' ');
			if (PrmComboBox->Enabled && !PrmComboBox->Text.IsEmpty())
				cmd.cat_sprintf(_T("_%s"), get_tkn(PrmComboBox->Text, _T(" : ")));

			TListBox *lp = KeyListBox;
			//ǉ
			if (add) {
				ibuf.cat_sprintf(_T("=%s"), cmd);
				lp->Items->Add(ibuf);
			}
			//ύX
			else {
				int kidx = -1;
				TStrings *sp = lp->Items;
				for (int i=0; i<sp->Count; i++) {
					if (SameText(sp->Names[i], ibuf)) { kidx = i;  break; }
				}
				int c_idx = lp->ItemIndex;
		 		if (kidx!=-1 && kidx!=c_idx) UserAbort(USTR_Registered);
				ibuf.cat_sprintf(_T("=%s"), cmd);
				lp->Items->Strings[c_idx] = ibuf;
			}
			SortKeyListBox(ibuf);

			SetCmdCombo();
			KeySetClick(NULL);
			KeyListBuf[KeyTabControl->TabIndex]->Assign(KeyListBox->Items);
			KeyListBoxClick(lp);
		}
		catch (EAbort &e) {
			msgbox_WARN(e.Message);
		}
	}
}

//---------------------------------------------------------------------------
//p[^̎Q
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::RefCmdPrmBtnClick(TObject *Sender)
{
	UnicodeString cmd = get_tkn(CmdComboBox->Text, ' ');
	//fBNg
	if (contained_wd_i(_T("ChangeDir|ChangeOppDir|CopyTo|MoveTo|OpenByExp|PlayList"), cmd)) {
		UnicodeString dnam = PrmComboBox->Text;
		if (UserModule->SelectDirEx(_T("p[^w : fBNg"), dnam)) PrmComboBox->Text = dnam;
	}
	//t@C
	else {
		if (USAME_TI(cmd, "ExeCommands")) {
			if (CmdFileListDlg->ShowToSelect()==mrOk)
				PrmComboBox->Text = "@" + to_relative_name(CmdFileListDlg->CmdFileName);
		}
		else {
			bool is_nwl = USAME_TI(cmd, "LoadWorkList");
			bool is_mnu = contained_wd_i(_T("ExeMenuFile|ContextMenu"), cmd);

			UserModule->PrepareOpenDlg(_T("p[^w : t@C"), NULL,
				(is_nwl? _T("*.nwl") : (USAME_TI(cmd, "SetColor")? _T("*.ini") : _T("*.*"))), RefParamPath);
			UnicodeString fnam;
			if (UserModule->OpenDlgToStr(fnam)) {
				RefParamPath = ExtractFilePath(fnam);
				if (is_nwl || is_mnu) fnam = to_relative_name(fnam);
				PrmComboBox->Text = fnam;
			}
		}
	}
}
//---------------------------------------------------------------------------
bool __fastcall TOptionDlg::CheckKeyAction(bool ok, bool add)
{
	if (ok && PrmComboBox->Enabled) {
		if (PrmComboBox->Style==csDropDownList)
			ok = (PrmComboBox->ItemIndex!=-1);
		else if (contained_wd_i(_T("ChangeDir|ChangeOppDir|ExeCommands|MaskFind"), get_tkn(CmdComboBox->Text, ' ')))
			ok = !PrmComboBox->Text.IsEmpty();
	}

	//2Xg[NJnL[̃`FbN
	if (ok) ok = !IsFirstCmdKey();

	//`FbN
	if (add && ok) {
		UnicodeString kbuf = GetCmdKeyStr();
		TStrings *sp = KeyListBox->Items;
		for (int i=0; i<sp->Count; i++)
			if (SameText(sp->Names[i], kbuf)) { ok = false;  break; }
	}

	return ok;
}

//---------------------------------------------------------------------------
//ǉ
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::AddKeyActionExecute(TObject *Sender)
{
	ChangeKeyList(true);
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::AddKeyActionUpdate(TObject *Sender)
{
	((TAction*)Sender)->Enabled =
		CheckKeyAction(KeyComboBox->ItemIndex!=-1 && CmdComboBox->ItemIndex!=-1, true);
}

//---------------------------------------------------------------------------
//ύX
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::ChgKeyActionExecute(TObject *Sender)
{
	ChangeKeyList(false);
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::ChgKeyActionUpdate(TObject *Sender)
{
	((TAction*)Sender)->Enabled =
		CheckKeyAction(KeyListBox->ItemIndex!=-1 && KeyComboBox->ItemIndex!=-1 && CmdComboBox->ItemIndex!=-1);
}

//---------------------------------------------------------------------------
//L[ݒ̍폜
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::DelKeyActionExecute(TObject *Sender)
{
	delete_ListItem(KeyListBox);
	SetCmdCombo();
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::DelKeyActionUpdate(TObject *Sender)
{
	((TAction*)Sender)->Enabled = (KeyListBox->ItemIndex!=-1);
}

//---------------------------------------------------------------------------
//
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::FindEditChange(TObject *Sender)
{
	TPageControl *pp = PageControl1;
	for (int i=0; i<pp->PageCount; i++) pp->Pages[i]->Tag = 0;
	pp->Repaint();
	FindMarkList->ClearAll();
	FindMarkList->MarkColor = col_OptFind;

	UnicodeString wd = FindEdit->Text;
	if (!wd.IsEmpty()) {
		//^uV[gɌ
		for (int i=0; i<pp->PageCount; i++) {
			TTabSheet *sp = pp->Pages[i];
			sp->Tag = (FindMarkList->SearchControl((TWinControl*)sp, wd)>0 || ContainsText(sp->Caption, wd))? 1 : 0;
			// Tag=1 
		}
		FindMarkList->ShowMark();
		PageControl1->Repaint();
		//ڂ܂ރ^uANeBu
		bool found = false;
		for (int i=0; i<pp->PageCount && !found; i++) {
			if (pp->Pages[i]->Tag==1) {
				pp->ActivePage = pp->Pages[i];
				found = true;
			}
		}
		if (!found) beep_Warn();
	}
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::PageControl1Change(TObject *Sender)
{
	HelpContext = PageControl1->ActivePage->HelpContext;

	if (!Sender || PageControl1->ActivePage==KeySetSheet) {
		KeyTabControl->TabIndex =
			LogWndListBox->Focused()? 4 :
			   (ScrMode==SCMD_FLIST)? (CurStt->is_IncSea? 1 : 0) :
			   (ScrMode==SCMD_TVIEW)? 2 :
			   (ScrMode==SCMD_IVIEW)? 3 : 0;

		KeyTabControlChange(KeyTabControl);
		KeyComboBox->ItemIndex = -1;
	}

	if (!Sender || PageControl1->ActivePage==ExtMenuSheet) ExtMenuListBoxClick(NULL);
	if (!Sender || PageControl1->ActivePage==ExtToolSheet) ExtToolListBoxClick(NULL);

	UserModule->InitializeListBox(GetCurListBox());
}

//---------------------------------------------------------------------------
//^u̕` (ʂ̋\)
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::PageControl1DrawTab(TCustomTabControl *Control, int TabIndex,
		const TRect &Rect, bool Active)
{
	TTabControl *tp = (TTabControl*)Control;
	//wi
	TCanvas *cv = tp->Canvas;
	cv->Brush->Color = (PageControl1->Pages[TabIndex]->Tag==0)? Color : col_OptFind;
	cv->FillRect(Rect);
	//^Cg
	cv->Font->Color = scl_WindowText;
	UnicodeString tstr = tp->Tabs->Strings[TabIndex];
	cv->TextOut(Rect.Left + (Rect.Width() - cv->TextWidth(tstr))/2, Rect.Top + 4, tstr);
}

//---------------------------------------------------------------------------
void __fastcall TOptionDlg::RefIniPatBtnClick(TObject *Sender)
{
	UnicodeString dnam = ExePath;
	if (UserModule->SelectDirEx(_T("pX"), dnam)) {
		dnam = to_path_name(dnam);
		if (((TComponent*)Sender)->Tag==1) R_IniPatEdit->Text = dnam; else L_IniPatEdit->Text = dnam;
	}
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::L_IniPatMod1RadioBtnClick(TObject *Sender)
{
	if (R_IniPatMod1RadioBtn->Checked) R_IniPatMod0RadioBtn->Checked = true;
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::R_IniPatMod1RadioBtnClick(TObject *Sender)
{
	if (L_IniPatMod1RadioBtn->Checked) L_IniPatMod0RadioBtn->Checked = true;
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::RefHomeWorkBtnClick(TObject *Sender)
{
	UserModule->PrepareOpenDlg(_T("z[[NXg̎w"), F_FILTER_NWL, _T("*.nwl"), WorkListPath);
	UserModule->OpenDlgToEdit(HomeWorkListEdit);
}

//---------------------------------------------------------------------------
//zF̃C|[g
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::InpColBtnClick(TObject *Sender)
{
	UserModule->PrepareOpenDlg(_T("zF̃C|[g"), F_FILTER_INI, _T("*.INI"));
	if (UserModule->OpenDlg->Execute()) {
		std::unique_ptr<TStringList> col_lst(new TStringList());
		std::unique_ptr<TStringList> ext_lst(new TStringList());
		std::unique_ptr<UsrIniFile> inp_file(new UsrIniFile(UserModule->OpenDlg->FileName));
		inp_file->ReadSection("Color", col_lst.get());
		inp_file->LoadListItems("ExtColList",	ext_lst.get());
		if ((col_lst->Count + ext_lst->Count)==0)
			msgbox_WARN("zFݒ肪܂");
		else {
			if (col_lst->Count>0) ColBufList->Assign(col_lst.get());
			if (ext_lst->Count>0) ExtColListBox->Items->Assign(ext_lst.get());
			//\XV
			ExtColListBox->Repaint();
			OptColListBox->Repaint();
			TimColListBox->Repaint();
		}
	}
}
//---------------------------------------------------------------------------
//zF̃GNX|[g
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::ExpColBtnClick(TObject *Sender)
{
	UserModule->PrepareSaveDlg(_T("zF̃GNX|[g"), F_FILTER_INI, _T("Export_Col.INI"));
	if (UserModule->SaveDlg->Execute()) {
		std::unique_ptr<UsrIniFile> exp_file(new UsrIniFile(UserModule->SaveDlg->FileName));
		exp_file->AssignSection("Color", ColBufList);
		std::unique_ptr<TStringList> ext_lst(new TStringList());
		ext_lst->Assign(ExtColListBox->Items);
		exp_file->SaveListItems("ExtColList", ext_lst.get());
		if (!exp_file->UpdateFile(true)) msgbox_ERR(USTR_FaildSave);
	}
}

//---------------------------------------------------------------------------
//L[ݒ̃C|[g
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::InpKeyBtnClick(TObject *Sender)
{
	UserModule->PrepareOpenDlg(_T("L[ݒ̃C|[g"), F_FILTER_INI, _T("*.INI"));
	if (UserModule->OpenDlg->Execute()) {
		std::unique_ptr<UsrIniFile> inp_file(new UsrIniFile(UserModule->OpenDlg->FileName));
		std::unique_ptr<TStringList> key_lst(new TStringList());
		inp_file->ReadSection("KeyFuncList", key_lst.get());
		if (key_lst->Count>0) {
			for (int i=0; i<MAX_KEYTABS; i++) {
				KeyListBuf[i]->Clear();
				UnicodeString modstr = GetCmdModeStr(i + 1);
				for (int j=0; j<key_lst->Count; j++){
					UnicodeString lbuf = key_lst->Strings[j];
					if (StartsText(modstr, lbuf)) KeyListBuf[i]->Add(lbuf);
				}
			}
			KeyTabControlChange(KeyTabControl);
			//̑̃L[ݒ
			UnicodeString sstr = inp_file->ReadString(SCT_Option, "DlgMoveShift");
			DlgMoveShiftCheckBox->Checked = ContainsText(sstr, KeyStr_Shift);
			DlgMoveCtrlCheckBox->Checked  = ContainsText(sstr, KeyStr_Ctrl);
			DlgMoveAltCheckBox->Checked	  = ContainsText(sstr, KeyStr_Alt);
			sstr = inp_file->ReadString(SCT_Option, "DlgSizeShift");
			DlgSizeShiftCheckBox->Checked = ContainsText(sstr, KeyStr_Shift);
			DlgSizeCtrlCheckBox->Checked  = ContainsText(sstr, KeyStr_Ctrl);
			DlgSizeAltCheckBox->Checked	  = ContainsText(sstr, KeyStr_Alt);
			sstr = inp_file->ReadString(SCT_Option, "IniSeaShift", "F:Ctrl+");
			IniSeaShiftCheckBox->Checked  = ContainsText(sstr, KeyStr_Shift);
			IniSeaCtrlCheckBox->Checked   = ContainsText(sstr, KeyStr_Ctrl);
			IniSeaAltCheckBox->Checked	  = ContainsText(sstr, KeyStr_Alt);
			IniSeaByNumCheckBox->Checked  = inp_file->ReadBool(SCT_Option, "IniSeaByNum");
			IniSeaBySignCheckBox->Checked = inp_file->ReadBool(SCT_Option, "IniSeaBySign");
		}
		else msgbox_WARN("L[ݒ肪܂");
	}
}
//---------------------------------------------------------------------------
//L[ݒ̃GNX|[g
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::ExpKeyBtnClick(TObject *Sender)
{
	UserModule->PrepareSaveDlg(_T("L[ݒ̃GNX|[g"), F_FILTER_INI, _T("Export_Key.INI"));
	if (UserModule->SaveDlg->Execute()) {
		std::unique_ptr<UsrIniFile> exp_file(new UsrIniFile(UserModule->SaveDlg->FileName));
		std::unique_ptr<TStringList> key_lst(new TStringList());
		KeyListBuf[KeyTabControl->TabIndex]->Assign(KeyListBox->Items);
		for (int i=0; i<MAX_KEYTABS; i++) key_lst->AddStrings(KeyListBuf[i]);
		key_lst->CustomSort(KeyComp_Key);
		exp_file->AssignSection("KeyFuncList",	key_lst.get());
		//̑̃L[ݒ
		UnicodeString sstr;
		if (DlgMoveShiftCheckBox->Checked) sstr += KeyStr_Shift;
		if (DlgMoveCtrlCheckBox->Checked)  sstr += KeyStr_Ctrl;
		if (DlgMoveAltCheckBox->Checked)   sstr += KeyStr_Alt;
		exp_file->WriteString(SCT_Option, "DlgMoveShift", sstr);
		sstr = EmptyStr;
		if (DlgSizeShiftCheckBox->Checked) sstr += KeyStr_Shift;
		if (DlgSizeCtrlCheckBox->Checked)  sstr += KeyStr_Ctrl;
		if (DlgSizeAltCheckBox->Checked)   sstr += KeyStr_Alt;
		exp_file->WriteString(SCT_Option, "DlgSizeShift", sstr);
		sstr.USET_T("F:");
		if (IniSeaShiftCheckBox->Checked) sstr += KeyStr_Shift;
		if (IniSeaCtrlCheckBox->Checked)  sstr += KeyStr_Ctrl;
		if (IniSeaAltCheckBox->Checked)   sstr += KeyStr_Alt;
		exp_file->WriteString(SCT_Option, "IniSeaShift", sstr);
		exp_file->WriteBool(SCT_Option, "IniSeaByNum",	IniSeaByNumCheckBox);
		exp_file->WriteBool(SCT_Option, "IniSeaBySign",	IniSeaBySignCheckBox);
		//o
		if (!exp_file->UpdateFile(true)) msgbox_ERR(USTR_FaildSave);
	}
}
//---------------------------------------------------------------------------
//E
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::AlRightBtnClick(TObject *Sender)
{
	IniWinWdEdit->Text = Screen->Width - EditToInt(IniWinLeftEdit);
	WinSizeChanged = IniWin1RadioBtn->Checked;
}
//---------------------------------------------------------------------------
//ő啝
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::MaxWdBtnClick(TObject *Sender)
{
	IniWinLeftEdit->Text = "0";
	IniWinWdEdit->Text	 = Screen->Width;
	WinSizeChanged = IniWin1RadioBtn->Checked;
}
//---------------------------------------------------------------------------
//ő卂
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::MaxHiBtnClick(TObject *Sender)
{
	IniWinTopEdit->Text = "0";
	IniWinHiEdit->Text	= Screen->Height;
	WinSizeChanged = IniWin1RadioBtn->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::IniWinSizeChange(TObject *Sender)
{
	WinSizeChanged = IniWin1RadioBtn->Checked;
}

//---------------------------------------------------------------------------
//OpenStandard R}hւ̊֘At
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::StdCmdListBoxClick(TObject *Sender)
{
	int idx = StdCmdListBox->ItemIndex;  if (idx==-1) return;
	FExtStdEdit->Text = StdCmdListBox->Items->Names[idx];
	UnicodeString cmd = StdCmdListBox->Items->ValueFromIndex[idx];
	if (contains_s(cmd, _T('_'))) {
		StdCmdPrmEdit->Text = get_PrmStr(cmd);
		cmd = get_CmdStr(cmd).UCAT_T("_");
	}

	for (int i=0; i<StdCmdComboBox->Items->Count; i++) {
		if (ContainsText(StdCmdComboBox->Items->Strings[i], cmd)) {
			StdCmdComboBox->ItemIndex = i;  break;
		}
	}

	StdCmdComboBoxChange(NULL);
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::StdCmdComboBoxChange(TObject *Sender)
{
	bool has_prm = contains_s(StdCmdComboBox->Text, _T("ExeCommands_"));
	StdCmdPrmEdit->Enabled	 = has_prm;
	RefStdCmdPrmBtn->Enabled = has_prm;
	if (!has_prm) StdCmdPrmEdit->Text = EmptyStr;
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::StdCmdListBoxDrawItem(TWinControl *Control, int Index, TRect &Rect,
		TOwnerDrawState State)
{
	TListBox *lp = (TListBox*)Control;
	TCanvas  *cv = lp->Canvas;
	cv->Font->Assign(lp->Font);
	int xp = Rect.Left + 2;
	int yp = Rect.Top + get_TopMargin(cv);

	SetHighlight(cv, State.Contains(odSelected));
	cv->FillRect(Rect);

	int w_x = 0;
	for (int i=0; i<lp->Count; i++) w_x = std::max(w_x, cv->TextWidth(lp->Items->Names[i]));
	cv->TextOut(xp, yp, lp->Items->Names[Index]);
	cv->TextOut(xp + w_x + 20, yp, lp->Items->ValueFromIndex[Index]);
}

//---------------------------------------------------------------------------
void __fastcall TOptionDlg::RefStdCmdPrmBtnClick(TObject *Sender)
{
	if (contains_i(StdCmdComboBox->Text, _T("ExeCommands_"))) {
		if (CmdFileListDlg->ShowToSelect()==mrOk)
			StdCmdPrmEdit->Text = "@" + to_relative_name(CmdFileListDlg->CmdFileName);
	}
}

//---------------------------------------------------------------------------
//WR}h̒ǉEύX
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::ChangeStdCmdList(bool add)
{
	if (FExtStdEdit->Text.IsEmpty() || StdCmdComboBox->Text.IsEmpty()) return;
	UnicodeString fext = Trim(FExtStdEdit->Text.LowerCase());	if (fext.IsEmpty()) return;
	if (fext[1]!='.') fext.Insert(".", 1);
	UnicodeString cmd = get_in_paren(StdCmdComboBox->Text);
	if (contains_s(cmd, _T('_'))) cmd += StdCmdPrmEdit->Text;

	//ǉ
	if (add) {
		StdCmdListBox->Items->Add(fext.cat_sprintf(_T("=%s"), cmd));
	}
	//ύX
	else {
		int idx = StdCmdListBox->ItemIndex;  if (idx==-1) return;
		StdCmdListBox->Items->Strings[idx] = fext.cat_sprintf(_T("=%s"), cmd);
	}
}
//---------------------------------------------------------------------------
//ǉ
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::AddStdCmdActionExecute(TObject *Sender)
{
	ChangeStdCmdList(true);
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::AddStdCmdActionUpdate(TObject *Sender)
{
	((TAction*)Sender)->Enabled = !FExtStdEdit->Text.IsEmpty() && !StdCmdComboBox->Text.IsEmpty();
}
//---------------------------------------------------------------------------
//ύX
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::ChgStdCmdActionExecute(TObject *Sender)
{
	ChangeStdCmdList(false);
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::ChgStdCmdActionUpdate(TObject *Sender)
{
	((TAction*)Sender)->Enabled
		 = StdCmdListBox->ItemIndex!=-1 && !FExtStdEdit->Text.IsEmpty() && !StdCmdComboBox->Text.IsEmpty();
}

//---------------------------------------------------------------------------
//Cxg
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::EventListBoxClick(TObject *Sender)
{
	EventCmdsEdit->Enabled = false;
	EventCmdsEdit->Text    = get_post_tab(EventListBox->Items->Strings[EventListBox->ItemIndex]);
	EventCmdsEdit->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::EventCmdsEditChange(TObject *Sender)
{
	if (!EventCmdsEdit->Enabled) return;

	int idx = EventListBox->ItemIndex;
	if (idx!=-1)
		EventListBox->Items->Strings[idx]
			= get_pre_tab(EventListBox->Items->Strings[idx]) + "\t" + EventCmdsEdit->Text;
}

//---------------------------------------------------------------------------
//R}h/j[t@C̕ҏW
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::EditFileActionExecute(TObject *Sender)
{
	int tag = ((TComponent*)Sender)->Tag;
	UnicodeString fnam = get_cmds_prm_file(
		(PageControl1->ActivePage==EventSheet)? ((tag==0)? EventCmdsEdit->Text : (tag==1)? TimerCmd1Edit->Text : TimerCmd2Edit->Text)
											  : MenuPrmEdit->Text);
	if (!fnam.IsEmpty()) open_by_TextEditor(fnam);
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::EditFileActionUpdate(TObject *Sender)
{
	int tag = ((TComponent*)Sender)->Tag;
	UnicodeString fnam = get_cmds_prm_file(
		(PageControl1->ActivePage==EventSheet)? ((tag==0)? EventCmdsEdit->Text : (tag==1)? TimerCmd1Edit->Text : TimerCmd2Edit->Text)
											  : MenuPrmEdit->Text);
	((TAction*)Sender)->Enabled = !fnam.IsEmpty();
}

//---------------------------------------------------------------------------
//m
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::OkActionExecute(TObject *Sender)
{
	//NyanFi zbgL[ēo^
	if (IsPrimary) {
		UnicodeString kstr;
		if (!HotKeyComboBox->Text.IsEmpty()) {
			if (HotShiftCheckBox->Checked) kstr += KeyStr_Shift;
			if (HotCtrlCheckBox->Checked)  kstr += KeyStr_Ctrl;
			if (HotAltCheckBox->Checked)   kstr += KeyStr_Alt;
			if (HotWinCheckBox->Checked)   kstr.UCAT_T("Win+");
			kstr += HotKeyComboBox->Text;
		}
		if (register_HotKey(ID_CALL_HOTKEY, kstr))
			CallHotKey = kstr;
		else {
			ModalResult    = mrNone;
			FindEdit->Text = EmptyStr;
			FindEdit->Text = "ĂяozbgL[";
			msgbox_ERR(GlobalErrMsg);
			return;
		}
		//AppList zbgL[ēo^
		kstr = EmptyStr;
		if (!AppKeyComboBox->Text.IsEmpty()) {
			if (AppShiftCheckBox->Checked) kstr += KeyStr_Shift;
			if (AppCtrlCheckBox->Checked)  kstr += KeyStr_Ctrl;
			if (AppAltCheckBox->Checked)   kstr += KeyStr_Alt;
			if (AppWinCheckBox->Checked)   kstr.UCAT_T("Win+");
			kstr += AppKeyComboBox->Text;
		}
		if (register_HotKey(ID_APP_HOTKEY, kstr))
			AppListHotKey = kstr;
		else {
			ModalResult    = mrNone;
			FindEdit->Text = EmptyStr;
			FindEdit->Text = "AppList";
			msgbox_ERR(GlobalErrMsg);
			return;
		}
	}

	//Rg[̃^OɂĕύXKp
	ApplyOptionByTag(this);

	//^OpȂݒ
	TempPath		 = to_path_name(TempDirEdit->Text);
	TempPathA		 = rel_to_absdir(TempPath);
	TempPathFTP.sprintf(_T("%s" TMP_FTP_D), TempPathA);
	MaxTasks		 = MaxTasksComboBox->ItemIndex + 1;
	AppListHotPrm	 = get_word_i_idx(_T("|FA|FL|FI|AO|LO|LI"), AppPrmComboBox->ItemIndex);
	ViewTxtLimitSize = EditToInt(LimitTxtEdit) * 1024;
	ViewBinLimitSize = std::max(StrToInt64Def(LimitBinEdit->Text, 0) * 1048576, 1048576LL);
	GetInfLimitSize  = std::max(EditToInt(LimitRarEdit) * 1048576, 1048576);

	UnicodeString tmp;
	//Migemo ď
	if (!SameText(MigemoPath, MigemoDirEdit->Text)) {
		MigemoPath = to_path_name(MigemoDirEdit->Text);
		delete usr_Migemo;
		usr_Migemo = new MigemoUnit(rel_to_absdir(MigemoPath));
		AddLog(tmp.sprintf(_T("  LOAD migemo.dll   %s"), usr_Migemo->DictReady? _T("OK") : _T("NONE")));
	}

	//Susie vOC̍ď
	if (!SameText(SpiDir, SusieDirEdit->Text)) {
		SpiDir = to_path_name(SusieDirEdit->Text);
		delete SPI;
		SPI = new SpiUnit(rel_to_absdir(SpiDir));
		if (SPI->PlgList->Count>0) {
			for (int i=0; i<SPI->PlgList->Count; i++) {
				spi_info *sp = SPI->PlgList->Items[i];
				AddLog(tmp.sprintf(_T("  LOAD %-12s %s"), ExtractFileName(sp->FileName), sp->FileType));
			}
		}
	}

	EtcEditorList->Assign(EtcEditorListBox->Items);

	ColorList->Assign(ColBufList);
	set_col_from_ColorList();

	ExtColList->Assign(ExtColListBox->Items);
	AssociateList->Assign(AssociateListBox->Items);
	OpenStdCmdList->Assign(StdCmdListBox->Items);

	TCheckListBox *lp = ExtMenuListBox;
	for (int i=0; i<lp->Count; i++) {
		TStringDynArray itm_buf = get_csv_array(lp->Items->Strings[i], EXTMENU_CSVITMCNT, true);
		itm_buf[4].sprintf(_T("%s"), lp->Checked[i]? _T("1") : _T("0"));
		lp->Items->Strings[i] = make_csv_rec_str(itm_buf);
	}
	ExtMenuList->Assign(lp->Items);

	lp = ExtToolListBox;
	for (int i=0; i<lp->Count; i++) {
		TStringDynArray itm_buf = get_csv_array(lp->Items->Strings[i], EXTTOOL_CSVITMCNT, true);
		itm_buf[5].sprintf(_T("%s"), lp->Checked[i]? _T("1") : _T("0"));
		lp->Items->Strings[i] = make_csv_rec_str(itm_buf);
	}
	ExtToolList->Assign(lp->Items);

	ViewFoldFitWin = FitFoldRadioBtn->Checked;

	KeyListBuf[KeyTabControl->TabIndex]->Assign(KeyListBox->Items);
	std::unique_ptr<TStringList> key_lst(new TStringList());
	for (int i=0; i<MAX_KEYTABS; i++) key_lst->AddStrings(KeyListBuf[i]);
	key_lst->CustomSort(KeyComp_Key);
	KeyFuncList->Assign(key_lst.get());

	IniPathMode[0] = L_IniPatMod1RadioBtn->Checked? 1 : L_IniPatMod2RadioBtn->Checked? 2 : 0;
	IniPathMode[1] = R_IniPatMod1RadioBtn->Checked? 1 : R_IniPatMod2RadioBtn->Checked? 2 : 0;
	IniWorkMode    = IniWork1RadioBtn->Checked? 1 : 0;
	IniWinMode	   = IniWin1RadioBtn->Checked? 1 : 0;

	DlgMoveShift = EmptyStr;
	if (DlgMoveShiftCheckBox->Checked) DlgMoveShift += KeyStr_Shift;
	if (DlgMoveCtrlCheckBox->Checked)  DlgMoveShift += KeyStr_Ctrl;
	if (DlgMoveAltCheckBox->Checked)   DlgMoveShift += KeyStr_Alt;
	DlgSizeShift = EmptyStr;
	if (DlgSizeShiftCheckBox->Checked) DlgSizeShift += KeyStr_Shift;
	if (DlgSizeCtrlCheckBox->Checked)  DlgSizeShift += KeyStr_Ctrl;
	if (DlgSizeAltCheckBox->Checked)   DlgSizeShift += KeyStr_Alt;

	//T[`
	IniSeaShift.USET_T("F:");
	if (IniSeaShiftCheckBox->Checked) IniSeaShift += KeyStr_Shift;
	if (IniSeaCtrlCheckBox->Checked)  IniSeaShift += KeyStr_Ctrl;
	if (IniSeaAltCheckBox->Checked)   IniSeaShift += KeyStr_Alt;

	//Cxg
	for (int i=0; i<MAX_EVENT_CMD; i++)
		 *(EventCmdList[i].sp) = get_post_tab(EventListBox->Items->Strings[i]);

	SetupTimer();
}
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::OkActionUpdate(TObject *Sender)
{
	HotKeyComboBox->Enabled =
		(HotShiftCheckBox->Checked || HotCtrlCheckBox->Checked || HotAltCheckBox->Checked || HotWinCheckBox->Checked);

	DirBraEdit->Color = ShowIconCheckBox->Checked? col_Invalid : scl_Window;
	DirKetEdit->Color = ShowIconCheckBox->Checked? col_Invalid : scl_Window;

	bool flag = (DlgMoveShiftCheckBox->Checked || DlgMoveCtrlCheckBox->Checked || DlgMoveAltCheckBox->Checked);
	DlgMoveLabel->Font->Color = flag? scl_WindowText : col_Invalid;
	DlgMoveEdit->Color		  = flag? scl_Window	 : col_Invalid;

	flag = (DlgSizeShiftCheckBox->Checked ||DlgSizeCtrlCheckBox->Checked || DlgSizeAltCheckBox->Checked);
	DlgSizeLabel->Font->Color = flag? scl_WindowText : col_Invalid;
	DlgSizeEdit->Color		  = flag? scl_Window	 : col_Invalid;

	InvColIfEmpty(NoWatchPathEdit);
	InvColIfEmpty(NoInfPathEdit);
	InvColIfEmpty(FExtGetInfEdit);
	InvColIfEmpty(FExtNoInfEdit);
	InvColIfEmpty(NoImgPrvPathEdit);
	InvColIfEmpty(FExtImgPrvEdit);
	InvColIfEmpty(FExtNoImgPrvEdit);
	InvColIfEmpty(ExtTxViewerEdit);
	ExtTxViewerFmtEdit->Color = ExtTxViewerEdit->Color;

	HdrStrEdit->Color = MarkdownCheckBox->Checked? col_Invalid : scl_Window;

	SelBaseOnlyCheckBox->Enabled  = SelByMouseCheckBox->Checked;
	SelIconCheckBox->Enabled	  = SelByMouseCheckBox->Checked;
	PrevTailCheckBox->Enabled	  = PrevTxtToInfCheckBox->Checked;
	AppendLogCheckBox->Enabled	  = SaveLogCheckBox->Checked;
	MaxLogFilesEdit->Enabled	  = SaveLogCheckBox->Checked;
	BeepTopEndCheckBox->Enabled   = HintTopEndCheckBox->Checked;
	SeekSwapNPCheckBox->Enabled   = SeekBindDirCheckBox->Checked;

	flag = (EditToInt(FwCntWarnEdit)==0 || EditToInt(FwTmWarnEdit)==0);
	FwCntWarnEdit->Color = flag? col_Invalid : scl_Window;
	FwTmWarnEdit->Color  = flag? col_Invalid : scl_Window;

	flag = (EditToInt(FwCntTaskFinEdit)==0 || EditToInt(FwTmTaskFinEdit)==0);
	FwCntTaskFinEdit->Color = flag? col_Invalid : scl_Window;
	FwTmTaskFinEdit->Color	= flag? col_Invalid : scl_Window;

	EventCmdsEdit->Enabled = (EventListBox->ItemIndex!=-1);
	RefCmdsBtn->Enabled	   = (EventListBox->ItemIndex!=-1);

	InvColIfEmpty(NopDtctTimeEdit);
	InvColIfEmpty(WatchIntervalEdit);
	InvColIfEmpty(FixedLimitEdit);

	ListPercentEdit->Color	 = !KeepOnResizeCheckBox->Checked? col_Invalid : scl_Window;

	ModalAlphaEdit->Color	 = !ModalScrCheckBox->Checked? col_Invalid : scl_Window;
	ModalColorBox->Color 	 = !ModalScrCheckBox->Checked? col_Invalid : scl_Window;

	RefFontBtn->Enabled		 = (FontComboBox->ItemIndex!=-1);
	RefColBtn->Enabled		 = (OptColListBox->ItemIndex!=-1);
	RefTimColBtn->Enabled	 = (TimColListBox->ItemIndex!=-1);

	if (!UserModule->SpuitEnabled()) {
		SpuitImage->Visible  = (OptColListBox->ItemIndex!=-1);
		SpuitImage2->Visible = (TimColListBox->ItemIndex!=-1);
		SpuitImage3->Visible = !ExtColorEdit->Text.IsEmpty();
	}

	DivDirInfUDCheckBox->Enabled = DivFlistUDCheckBox->Checked;

	int bgmod = BgImgModeComboBox->ItemIndex;
	BgImgSubModeComboBox->Enabled = (bgmod==1 || bgmod==2);
	BgImg1Edit->Color	= (bgmod==0 || bgmod==3)?		col_Invalid : scl_Window;
	BgImg2Edit->Color	= (bgmod!=2)?					col_Invalid : scl_Window;
	HideTimeEdit->Color = !HideScrCheckBox->Checked?	col_Invalid : scl_Window;
	TileIfSzEdit->Color = !TileIfCheckBox->Checked?		col_Invalid : scl_Window;
	InvColIfEmpty(SpImgEdit);
	InvColIfEmpty(SpImg2Edit);

	CloseOtherCheckBox->Enabled = !TaskTrayCheckBox->Checked;
	if (TaskTrayCheckBox->Checked) CloseOtherCheckBox->Checked = true;
}

//---------------------------------------------------------------------------
//LZ
//---------------------------------------------------------------------------
void __fastcall TOptionDlg::CanButtonClick(TObject *Sender)
{
	//X|Cg̃LZ
	if (UserModule->SpuitEnabled()) UserModule->EndSpuit();
	//
	else ModalResult = mrCancel;
}

//---------------------------------------------------------------------------
//wv
//---------------------------------------------------------------------------
bool __fastcall TOptionDlg::FormHelp(WORD Command, NativeInt Data, bool &CallHelp)
{
	if (Command==HELP_CONTEXT || Command==HELP_CONTEXTPOPUP) {
		if (PageControl1->ActivePage==KeySetSheet && (CmdComboBox->Focused() || PrmComboBox->Focused())) {
			UnicodeString topic;

			switch (KeyTabControl->TabIndex) {
			case 0: topic.UCAT_T(HELPTOPIC_FL);		break;	//t@C[
			case 1: topic.UCAT_T(HELPTOPIC_IS);		break;	//INC.T[`
			case 2: topic.UCAT_T(HELPTOPIC_TV);		break;	//eLXgrA[
			case 3: topic.UCAT_T(HELPTOPIC_IV);		break;	//C[WrA[
			case 4: topic.UCAT_T(HELPTOPIC_CILW);	break;	//O
			}

			UnicodeString kwd = get_tkn(CmdComboBox->Text, ' ');
			if (!contains_s(topic, _T('#')) && !kwd.IsEmpty() && !starts_Dollar(kwd))
				topic.cat_sprintf(_T("#%s"), kwd);

			HtmlHelpTopic(topic.c_str());
		}
		else {
			HtmlHelpContext(Data);
		}
		CallHelp = false;
	}
	return true;
}
//---------------------------------------------------------------------------

